/**********************************************************************
 * ====================================================================
 * Copyright (c) 2001-2010 GAMEVILE. Inc., All rights reserved.
 * DON'T COPY OR REDISTRIBUTE THIS SOURCE CODE WITHOUT PERMISSION.
 * ====================================================================
 * 
 * FILENAME 	: NexusUtils.java
 * AUTHOR   	: hansok
 * Mail		: hansok@gamevil.com
 * DATE 	: 2011. 7. 12.
 *
 * Note : ========================================
 *
 ***********************************************************************/
package com.gamevil.nexus2.v9;

//#if __V9__
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Calendar;
import java.util.Locale;
import java.util.TimeZone;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import com.gamevil.nexus2.Natives;
import com.gamevil.nexus2.NexusGLActivity;
import com.gamevil.nexus2.xml.FileDownThread;

import android.app.Activity;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.os.Environment;
import android.os.Handler;
import android.os.StatFs;
import android.provider.Settings;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Toast;


public class NexusUtilsV9 {

	
	public static final String PREFS_NAME = "MyPrefsFile";
	public static final String STR_PROFILED = "profiled";
	public static final String STR_PHONE_NUMBER = "phoneNumber";
	public static final String STR_VERSION = "profilVersion";
	public static final String STR_C2DM_CHECKED = "c2dmAccept";
	public static final String STR_IS_ROOTING = "isRooting";
	public static final String STR_CARRIER = "carrier";
	
	
	//게임 ?이??일??Preference ?름
	public static final String PREFS_SAVE_NAME = "gameSave";
    
//#if __TEST__	
	//# private static String testPhoneNumber;
	//# public static void setTestPhoneNumber(String _number)
	//# {
		//# testPhoneNumber = _number;
		//# System.out.println("testPhoneNumber " + testPhoneNumber);
	//# }
	//# public static void releaseTestPhoneNumber()
	//# {
		//# testPhoneNumber = null;
	//# }
//#endif	
	
	public static String getPhoneNumber(Context _context)
	{
		String str = null;
		 str = ((TelephonyManager)_context.getSystemService(Context.TELEPHONY_SERVICE)).getLine1Number(); /// ?넘??기??? 추? 2010.09.10
		 
		//#if __TEST__
		 //# System.out.println("getPhoneNumber testPhoneNumber " + testPhoneNumber);
		 //# if(testPhoneNumber != null && testPhoneNumber.length() >5)
		 //# {
			 //# str = testPhoneNumber;
			 //# System.out.println("getPhoneNumber testPhoneNumber " + testPhoneNumber);
		 //# }
		//#endif
		 
		 int length = 0;
		 if(str != null) length = str.length();

		 
	  	 //010,011 ??처럼 01??작?? ?는 ?번?? ?면 ?에??10?리??효??번호??용?다.	
	  	 //?이?쉐?링 ? 
	  	 if( length >= 10 && !str.substring(0, 2).equals("01"))
	  	 {
	  		 
	  		 StringBuffer front = new StringBuffer();
	  		 String rear = str.substring(length-7, length);
	  		 
	  		 String checkSet = str.substring(0, length-7);
	  		 
	  		 int offset = 0;
			 if((offset = checkSet.indexOf("010"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("011"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("016"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("017"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("018"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("019"))>0)
			 {
				 front.append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("10"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("11"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("16"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("17"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("18"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 else if((offset = checkSet.indexOf("19"))>0)
			 {
				 front.append("0").append(checkSet.substring(offset));
			 }
			 
			if(offset>0)
			{
				str = front.append(rear).toString();
			}
			else
			{
				str = "01"+str.substring(length-9, length);
			}
			
	  	}
		
	  	if(str == null || length < 5 || !isDomestic(_context))
	  	{
	  		str = "0";
	  	}
	 

	  	return str;
	}
	
	public static String getOldPhoneNumber(Context _context)
	{
		String str = ((TelephonyManager)_context.getSystemService(Context.TELEPHONY_SERVICE)).getLine1Number(); /// ?넘??기??? 추? 2010.09.10
		int length = 0;
		if(str != null) length = str.length();
		
	  	//010,011 ??처럼 01??작?? ?는 ?번?? ?면 ?에??10?리??효??번호??용?다.	
	  	//?이?쉐?링 ? 
	  	if( length >= 10 && !str.substring(0, 2).equals("01"))
	  	{
			str = "01"+str.substring(length-9, length);
	  	}

	  	if(str == null || length < 5)
	  	{
	  		str = "0";
	  	}
	
	  	return str;
	}
	
	public static String getPhoneModel()
	{
		String _model = Build.MODEL;
		if(_model.length() > 20)
		{
			_model = _model.substring(0, 20);
		}

		return _model;
	}
	
	public static String getMacAddress(Context _context)
	{ 
		WifiManager wm = (WifiManager)_context.getSystemService(Context.WIFI_SERVICE);
		String macAdd = wm.getConnectionInfo().getMacAddress();
		if(macAdd==null||macAdd.length()<5)
		{
			macAdd = "0";
		}
		return macAdd;
	}
	
	public static String getDeviceID(Context _context)
	{
		String _imei = ((TelephonyManager)_context.getSystemService(Context.TELEPHONY_SERVICE)).getDeviceId();
		if(_imei==null||_imei.length()<5)
		{
			_imei = "0";
		}
		return _imei;
	}
	
	public static String getAndroidID(Context _context)
	{
		String _androidID = Settings.Secure.getString(_context.getContentResolver(), Settings.Secure.ANDROID_ID);
		if(_androidID==null||_androidID.length()<5)
		{
			_androidID = getDeviceID(_context);
		}
		else if(_androidID.equals("9774d56d682e549c"))
		{
			_androidID = getDeviceID(_context);
		}
		return _androidID;
	}
	
	public static String getSerial()
	{
		if( Build.VERSION.SDK_INT  < 9 )
			return null;
		
		return Build.SERIAL;
	}
	
	public static String getSimSerialNumber(Context _context)
	{
		
		String _serial = ((TelephonyManager)_context.getSystemService(Context.TELEPHONY_SERVICE)).getSimSerialNumber();
		
		if(_serial==null||_serial.length()<5)
		{
			_serial = "0";
		}
		
		return _serial;
	}
	
	public static String getOsVersion()
	{
		String version = "AD OS_" + Build.VERSION.SDK_INT;
		return version;
	}
	
	
	public static String getLanguageCode()
	{
		return Locale.getDefault().toString();
	}

	
	public static String getInetHostAddress(String _hostUrl)
	{
		InetAddress nyu = null;
		String rtnAddress = null;
		try {
			nyu = InetAddress.getByName(_hostUrl);
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			rtnAddress = "0";
		}
		rtnAddress = nyu.getHostAddress();

		return rtnAddress;
	}
	
//========================================
// 추? ?운로드 ?	
//========================================		
	
	public static int ERROR_FAIL = -1;
	public static int ERROR_DOWNLOAD_FAIL = -2;		// ?운로드 ?패
	public static int ERROR_UNZIP_FAIL = -3;		// ?축?제 ?패
	public static int ERROR_MAKEFOLDER_FAIL = -4;	// ?더?성 ?패
	
	public static FileDownThread mThread = null;
	public static int mFileDownRet;
	
	/// SD카드 ?운로드 경로
	public final static String mSdcardPath = "/sdcard/gamevil/";
	
	private static String getAbsolueFilePath() {
		String filePath = NexusGLActivity.myActivity.getFilesDir()
				.getAbsolutePath();
		// System.out.println("Java: getAbsolueFilePath :: "+filePath);
		return filePath;
	}
	
	public static String GetAbsolutPath()
	{    	
		String filepath = getAbsolueFilePath();
		filepath += "/";    	
		return filepath;
	}
	
	/// ??메모??용? ?량
	static public long getAvailableInternalMemorySize() {
		long size = -1;
		File path = Environment.getDataDirectory();
		StatFs stat = new StatFs(path.getPath());
		long blockSize = stat.getBlockSize();
		long availableBlocks = stat.getAvailableBlocks();
		size = availableBlocks * blockSize;

		return size;
	}
	
	/// ??메모??체 ?량
	static public long getTotalInternalMemorySize() {
		File path = Environment.getDataDirectory();
		StatFs stat = new StatFs(path.getPath());
		long blockSize = stat.getBlockSize();
		long totalBlocks = stat.getBlockCount();
		return totalBlocks * blockSize;
	}
	
	/// SD카드 ?용? ??
	public static boolean canUseExternalMemory() { 
		String state = Environment.getExternalStorageState();
		return state.equals(Environment.MEDIA_MOUNTED);
	} 
	
	/// SD카드 ?용? ?량
	public static long getExteranlMemoryAvailableSize(){ 
		long size = -1;
		if( canUseExternalMemory() ){
			File exmemPath = Environment.getExternalStorageDirectory();
			if( exmemPath != null ){
				StatFs fs = new StatFs(exmemPath.getPath());
				long bkSize = fs.getBlockSize();
				long avaBlocks = fs.getAvailableBlocks();
				size = bkSize * avaBlocks;
			}
		}
		return size;
	} 
	
	/// SD카드 ?체 ?량
	public static long getExteranlMemorySize(){ 
		long size = -1;
		if( canUseExternalMemory() ){
			File exmemPath = Environment.getExternalStorageDirectory();
			if( exmemPath != null ){
				StatFs fs = new StatFs(exmemPath.getPath());
				long bkSize = fs.getBlockSize();
				long bkCount = fs.getBlockCount();
				size = bkSize * bkCount;
			}
		}
		return size;
	}
	
	/// 메모???경로???더 ?성
	/// ?더?존재??경우 -1값을 리턴
	public static int makeFolder(boolean issdcard, String path){
		Log.d("#Native#","makeFolder > issdcard = "+ issdcard);	
		Log.d("#Native#","makeFolder > path = "+ path);	
		File f0 = null;
		String makepath;
		if(issdcard)
		{
			makepath = mSdcardPath;
		}
		else
		{
			makepath = GetAbsolutPath();		
		}
			
		f0 = new File(makepath + path);
		if (f0.exists())
		{
			return -1;
		}
		else
		{
			File dir = new File(makepath, path);
			dir.mkdirs();
			Log.d("#Native#","makeFolder > dir.mkdirs(); "+ makepath+path);	
			return 1;
		}
	}
	
	public static boolean unZip(String file, String path){    	
		String locationPath = mSdcardPath + path;
		try 
		{   
			System.out.println("| locationPath : "+ locationPath);
			FileInputStream fp = new FileInputStream( locationPath + file);
			ZipInputStream in = new ZipInputStream(fp);
			ZipEntry ze=  null;
			try 
			{
				while((ze=in.getNextEntry()) != null )
				{
					
					String entryName = ze.getName();
					int lastIdx = entryName.lastIndexOf("/");
					if(lastIdx > 0)
					{
						String subDirPath = locationPath + entryName.substring(0, lastIdx);
						File f = new File(subDirPath);
						if(!f.exists())
						{
	                        f.mkdir();							
						}
					}

					OutputStream out = new FileOutputStream(locationPath+ze.getName());
					byte[] buf = new byte[128];
					int len;
					while((len = in.read(buf)) > 0)
					{
						out.write(buf,0,len);
					}
					in.closeEntry();
					out.close();
				}
			}
			catch (IOException e) 
			{
				e.printStackTrace();
				DeleteFolder(path);
				
				return false;
			}
			
			try 
			{
				in.close();
			} 
			catch (IOException e) 
			{
				e.printStackTrace();
				return false;
			}
		}
		catch (FileNotFoundException e) 
		{
			try 
			{    		
				locationPath = GetAbsolutPath() + path;
				System.out.println("| locationPath : "+ locationPath);
				FileInputStream fp = new FileInputStream( locationPath + file);
				ZipInputStream in = new ZipInputStream(fp);
				ZipEntry ze;
				try 
				{
					while((ze=in.getNextEntry()) != null )
					{
						String entryName = ze.getName();
						int lastIdx = entryName.lastIndexOf("/");
						if(lastIdx > 0)
						{
							String subDirPath = locationPath + entryName.substring(0, lastIdx);
							File f = new File(subDirPath);
							if(!f.exists())
							{
		                        f.mkdir();							
							}
						}
						
						OutputStream out = new FileOutputStream(locationPath+ze.getName());
						byte[] buf = new byte[128];
						int len;
						while((len = in.read(buf)) > 0)
						{
							out.write(buf,0,len);
						}
						out.close();
					}
				}
				catch (IOException e1) 
				{
					e1.printStackTrace();
					DeleteFolder(path);
					
					return false;
				}
				
				try 
				{
					in.close();
				} 
				catch (IOException e1) 
				{
					e1.printStackTrace();
					return false;
				}
			} 
			catch (FileNotFoundException e1) 
			{
				e1.printStackTrace();
				return false;
			}
		}

		File f0;
		f0 = new File(mSdcardPath + path + file);
		if (f0.exists()) 
		{
			File dir = new File(mSdcardPath , path + file) ;
			dir.delete();
			f0.delete();
		}		
		else
		{
			f0 = new File(GetAbsolutPath() + path + file);
			if(!f0.exists())
			{
				return false;
			}
			File dir = new File(GetAbsolutPath() , path + file) ;
			dir.delete();
			f0.delete();
		}
		
		return true;
	}
	
	
	
	
	/// Nexus.cpp?서 불려??수
	/// ?라미터 - fileUrl : http ?체 주소
	/// 		  filePath : ?? 경로
	///			  fileName : 받을 ?일 ?름
	///			  fileSize : ?일 ?이?
	/// 리턴?- ?수 : (?상) ?운로드???일 ?이?
	///			?수 : Error
	public static int GetFileFromHttp(String fileUrl, String filePath, String fileName, int fileSize, boolean showProgress)
	{
		mFileDownRet = -1;
		System.out.println("+-------------------------------");
		System.out.println("|	GetFileFromHttp	 ");
		System.out.println("|	GetFileFromHttp	fileUrl "+fileUrl);
		System.out.println("|	GetFileFromHttp	filePath "+filePath);
		System.out.println("|	GetFileFromHttp	fileName "+fileName);
		System.out.println("+-------------------------------");
		DeleteFolder(filePath);
		
		if(NexusGLActivity.mPause == false)
		{
			Natives.showLoadingDialog();
			System.out.println("+-------------------------------");
			System.out.println("|	FileDownThread create	 ");
			System.out.println("+-------------------------------");
			mThread = new FileDownThread(fileUrl, filePath, fileName, fileSize, showProgress);
			mThread.start();
			
			try {
				mThread.join();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Natives.hideLoadingDialog();
			}
		}
		Natives.hideLoadingDialog();
		return mFileDownRet;
	}
	
	public static int GetFileFromHttp(String fileUrl, String filePath, String fileName, int fileSize)
	{
		return GetFileFromHttp( fileUrl, filePath,  fileName, fileSize, true);
	}
	
	public static boolean DeleteFolder(String szPath)
	{

		System.out.println("+-------------------------------");
		System.out.println("|	DeleteFolder: "+ szPath);
		System.out.println("+-------------------------------");
		File targetFolder = new File(GetAbsolutPath() + szPath);
		if(!targetFolder.exists())
		{
			targetFolder = new File(mSdcardPath + szPath);
			if(!targetFolder.exists())			
				return true;
		}
		
		return DoDeleteFolder(targetFolder);
	}
	
	private static boolean DoDeleteFolder(File targetFolder)
	{
		File[] childFile = targetFolder.listFiles();
		boolean confirm = false;
		int size = childFile.length;
	
		if (size > 0)
		{
			for (int i = 0; i < size; i++)
			{
				if (childFile[i].isFile())
				{
					/// confirm : ?일 ?? ?공 ??
					confirm = childFile[i].delete();
				}
				else
				{
					/// ?렉?리??경우 ?? ?일 ?? ??
					DoDeleteFolder(childFile[i]);
				}
			}
		}
		targetFolder.delete();
	
		return (!targetFolder.exists());
	}
	
	public static String getStringFromBytes(byte[] _data)
	{
		int dataLength = _data.length;
		StringBuffer sb = new StringBuffer(dataLength);
		for(int _i = 0 ; _i < dataLength ; _i++)
		{
			sb.append(_data[_i]);
		}
		return sb.toString();
	}

	public static void setLocalPushNotification(Context _context, int _id, String _title, String _sender, String _message, String _callbackUrl, int _seconds)
	{
		 Intent intent = new Intent("com.gamevil.push.intent.LOCAL");
		 intent.addCategory(_context.getPackageName());
		 intent.putExtra("title", _title);
		 intent.putExtra("sender", _sender);
		 intent.putExtra("msg", _message);
		 intent.putExtra("callback", _callbackUrl);
         PendingIntent sender = PendingIntent.getBroadcast(_context, _id, intent, PendingIntent.FLAG_UPDATE_CURRENT);

         // We want the alarm to go off 30 seconds from now.
         Calendar calendar = Calendar.getInstance();
         calendar.setTimeInMillis(System.currentTimeMillis());
         calendar.add(Calendar.SECOND, _seconds);

         // Schedule the alarm!
         AlarmManager am = (AlarmManager)_context.getSystemService(Activity.ALARM_SERVICE);
         am.set(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis(), sender);
	}
    
	public static void cancelLocalPushNotification(Context _context, int _id)
	{
		 Intent intent = new Intent("com.gamevil.push.intent.LOCAL");
		 intent.addCategory(_context.getPackageName());
         PendingIntent sender = PendingIntent.getBroadcast(_context, _id, intent, PendingIntent.FLAG_UPDATE_CURRENT);

         // Schedule the alarm!
         AlarmManager am = (AlarmManager)_context.getSystemService(Activity.ALARM_SERVICE);
         am.cancel(sender);
	}
	
    public static void setUserAcceptC2dm(Context context, boolean _isAccept)
    {
		SharedPreferences settings = context.getSharedPreferences(NexusUtilsV9.PREFS_NAME,  Activity.MODE_PRIVATE);
    	SharedPreferences.Editor prefEditor = settings.edit();
    	prefEditor.putBoolean(NexusUtilsV9.STR_C2DM_CHECKED, _isAccept);
    	prefEditor.commit();
    }
    
    public static boolean isUserAcceptC2dm(Context context)
    {
		SharedPreferences settings = context.getSharedPreferences(NexusUtilsV9.PREFS_NAME,  Activity.MODE_PRIVATE);
		return settings.getBoolean(NexusUtilsV9.STR_C2DM_CHECKED, true);
    }
    
    
    
    
	
	public static boolean isAndroidPlayer(Context _context)
	{
		TelephonyManager tManager = (TelephonyManager)_context.getSystemService(Context.TELEPHONY_SERVICE);
		int simState = tManager.getSimState();
		return (tManager.getPhoneType() == 0)||(simState == TelephonyManager.SIM_STATE_ABSENT || simState == TelephonyManager.SIM_STATE_UNKNOWN ) ? true : false;
	}
	
    public static int isNetAvailable(Context _context)
    {
    	boolean _reachable = false;
    	final ConnectivityManager conn_manager = (ConnectivityManager)_context.getSystemService(Context.CONNECTIVITY_SERVICE);

    	final NetworkInfo network_info = conn_manager.getActiveNetworkInfo();
    	if ( network_info != null && network_info.isConnected() )
    	{
    		_reachable = true;
    	}
    	
    	return _reachable ? network_info.getType() : -1;
    }
    
    public static AlertDialog getNonCancelalbeAlertDialog(Context _context, String _title, String _message)
	{
		AlertDialog.Builder builder = new AlertDialog.Builder(_context);

        builder.setCancelable(false);
        builder.setTitle(_title);
        builder.setMessage(_message);
        builder.setIcon(android.R.drawable.ic_dialog_alert);

        builder.setNeutralButton("OK", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {

            	System.out.println("|	setNeutralButton.  OK" );
            	android.os.Process.killProcess(android.os.Process.myPid());
            }
        });

        AlertDialog alert = builder.create();

        alert.setOwnerActivity((Activity)_context);
        alert.setOnDismissListener(new DialogInterface.OnDismissListener() {

            @Override
            public void onDismiss(DialogInterface dialog) {

            	System.out.println("|	setOnDismissListener.  OK" );
                   // showAlert();
            	android.os.Process.killProcess(android.os.Process.myPid());
            }
        });	
        return alert;
	}
    
	public static String getCarrierName(Context _context)
	{
		TelephonyManager tm = (TelephonyManager) _context.getSystemService(Context.TELEPHONY_SERVICE);
		String rtn = tm.getNetworkOperator();
		
		if(rtn==null)
		{
			rtn = "0";
		}
		else
		{
			int length = rtn.length();
			if(length>4)
			{
				String mcc = rtn.substring(0, 3);
				String mnc = rtn.substring(length-2,length);
				
				if(mcc.equals("450"))
				{
					rtn = mcc+mnc;
				}
			}
			else
			{
				rtn = "0";
			}
			
		}
		
		return rtn;
	}
    
	public static String getLanguage(Context _context)
	{
		String rtn = Locale.getDefault().toString();
		if(rtn == null)
			rtn = "0";
		return rtn ;
	}
	
	public static boolean isDomestic(Context _context)
	{
		String name = getCarrierName(_context);
		System.out.println("+-------------------------------");
		System.out.println("|	isDomestic	Carrier Name = " + name);
		System.out.println("+-------------------------------");
		
		if(name.equals("45005")|| name.equals("45008")|| name.equals("45006"))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public static String getTimeZone(Context _context)
	{
		Configuration userConfig = new Configuration();
		Settings.System.getConfiguration( _context.getContentResolver(), userConfig );
		Calendar cal = Calendar.getInstance( userConfig.locale);
		TimeZone tz = cal.getTimeZone();
		
		String rtn = tz.getDisplayName(false,TimeZone.SHORT,Locale.getDefault());
		if(rtn == null)
			rtn = "0";
		return rtn;
	}
	
	public static boolean isRooted() {
// Galaxy Nexus(ICS) ?서 ?상 ?작?? ?고 게임?행??못하??어 ?? [2012/02/15 hansok]
//	    Process exec;
//	    System.out.println("### isRooted ###");
//	    try {
//
//	        exec = Runtime.getRuntime().exec(new String[]{"su","-c"});
//
//	        final OutputStreamWriter out = new OutputStreamWriter(exec.getOutputStream());
//	        out.write("exit 1");
//	        out.flush();
//
//	        System.out.println("### su command executed successfully ###");
//	        return true; 
//	    } catch (IOException e) {
//	        // TODO Auto-generated catch block
//	    	System.out.println("### isRooted Exception ###" + e.toString());
//	        e.printStackTrace();
//	    }  
	    return false; 
	}
}
//#endif
