/**********************************************************************
 * ====================================================================
 * Copyright (c) 2001-2010 GAMEVILE. Inc., All rights reserved.
 * DON'T COPY OR REDISTRIBUTE THIS SOURCE CODE WITHOUT PERMISSION.
 * ====================================================================
 * 
 * FILENAME 	: ProfileData.java
 * AUTHOR   	: hansok
 * Mail		: hansok@gamevil.com
 * DATE 	: 2011. 9. 2.
 *
 * Note : ========================================
 *
 ***********************************************************************/
package com.gamevil.nexus2.v9;

//#if __V9__

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;

public class ProfileDataV9 {

	public static final byte SALE_CODE_ANDROID_PLUS = 10; //10:?드로이?정??
	public static final byte SALE_CODE_ANDROID_FREE = 14; //14:?드로이??무료
	
	public static final byte CARRIER_SKT 			= 1;
	public static final byte CARRIER_KT 			= 2;
	public static final byte CARRIER_LGU 			= 3;
	public static final byte CARRIER_IOS 			= 4;
	public static final byte CARRIER_ANDROID 		= 5;
	
	public static final byte CARRIER_QIIP			= 7;
		
	//=============================================
	// Gamevil Certification Info V9
	//=============================================
	// Note : GAME_ID??반듯??게임빌에??발급 받? ?이?? 
	//        ?용?여???니??
	//
	//ALE_CODE ?? (10:?드로이?정??11:?이??14:?드로이??무료)
	//==============================================

	private static int		gid;
	private static byte		company;
	private static byte		sale_cd;
	private static String 	app_ver;
	private static byte		is_rooting = 0;

	private static String 	flurryApiKey;
	
	//=======================================
	// ??통?별?발급 받? ID??는??
	//=======================================
	private static String qiipAID;
	private static String sktAID;
	private static String ktCID,ktAID;
	private static String lguARMID, lguAppID;
		
	private static boolean isUsingBase64;
	private static boolean isProfileSent;
	
	private static Bundle profileBundle; 
	
	public static void makeProfileBundleData()
	{
		if(profileBundle!=null)
		{
			profileBundle.clear();
			profileBundle = null;
		}
		profileBundle = new Bundle();

		profileBundle.putInt("gameID", gid);
		profileBundle.putByte("carrierId",company);
		profileBundle.putByte("saleCode", sale_cd);		
		profileBundle.putString("appVersion",app_ver);
		profileBundle.putByte("isRooted", is_rooting);
		
		profileBundle.putString("flurryApiKey",flurryApiKey);
		
	
		profileBundle.putString("qiipAID",qiipAID);
		profileBundle.putString("sktAID",sktAID);
		profileBundle.putString("ktCID",ktCID);
		profileBundle.putString("ktAID",ktAID);
		profileBundle.putString("lguARMID",lguARMID);
		profileBundle.putString("lguAppID",lguAppID);
			
		profileBundle.putBoolean("isUsingBase64",isUsingBase64);
		profileBundle.putBoolean("isProfileSent",isProfileSent);
	}
	
	public static Bundle getProfileBundle()
	{
		return profileBundle;
	}
	
	public static void setProfileWithBundle(Bundle _bundle)
	{
		if(_bundle != null)
		{
			gid 		=  _bundle.getInt("gameID", 13464);		
			company 	=  _bundle.getByte("carrierId", (byte)1);	
			sale_cd 	=  _bundle.getByte("saleCode", (byte)0);
			app_ver 	=  _bundle.getString("appVersion");
			is_rooting 	=  _bundle.getByte("isRooted", (byte)0);	
			
			flurryApiKey =  _bundle.getString("flurryApiKey");
			
			qiipAID		=	_bundle.getString("qiipAID");
			sktAID		=  _bundle.getString("sktAID");
			ktCID		=  _bundle.getString("ktCID");
			ktAID		=  _bundle.getString("ktAID");
			lguARMID	=  _bundle.getString("lguARMID");
			lguAppID	=  _bundle.getString("lguAppID");
				
			isUsingBase64=  _bundle.getBoolean("isUsingBase64");
			isProfileSent=  _bundle.getBoolean("isProfileSent");
		}
		
		System.out.println("+-------------------------------");
		System.out.println("|	setProfileWithBundle	 " );
		System.out.println("|	gameID	 " + gid);
		System.out.println("|	saleCode	 " + sale_cd);
		System.out.println("|	company	 " + company);
		System.out.println("|	app_ver	 " + app_ver);
		System.out.println("|	is_rooting	 " + is_rooting);
		System.out.println("|	flurryApiKey	 " + flurryApiKey);
		System.out.println("|	sktAID	 " + sktAID);
		System.out.println("|	ktCID	 " + ktCID);
		System.out.println("|	ktAID	 " + ktAID);
		System.out.println("|	lguARMID	 " + lguARMID);
		System.out.println("|	lguAppID	 " + lguAppID);
		System.out.println("|	isUsingBase64	 " + isUsingBase64);
		System.out.println("|	isProfileSent	 " + isProfileSent);
		System.out.println("+-------------------------------");
	}
	
//	public static boolean isProfileSent() {
//		return isProfileSent;
//	}
//
//	public static void setIsProfileSent(boolean _isProfileSent) {
//		ProfileDataV9.isProfileSent = _isProfileSent;
//	}

	public static void setUsingNetworkEncryption(boolean _useEncryption)
	{
		isUsingBase64 = _useEncryption;
	}
	
	public static boolean isUsingNetworkEncryption()
	{
		return isUsingBase64;
	}
	
	public static void setAcceptTerms(Context _context, boolean _accepted)
	{
	    SharedPreferences settings = _context.getSharedPreferences(NexusUtilsV9.PREFS_NAME,  Activity.MODE_PRIVATE);
	    SharedPreferences.Editor editor = settings.edit();
	    editor.putBoolean("accept_terms", _accepted);
	    editor.commit();
	}
	
	
	public static int isTermsAccepted(Context _context)
	{
    	 SharedPreferences settings = _context.getSharedPreferences(NexusUtilsV9.PREFS_NAME,  Activity.MODE_PRIVATE);
        return settings.getBoolean("accept_terms", false)? 1 : 0;
	}
	
	
	public static boolean isProfileSaved(Context _context)
	{
	   	SharedPreferences settingsLicense = _context.getSharedPreferences(NexusUtilsV9.PREFS_NAME,  Activity.MODE_PRIVATE);
	   	String _savedAppVersion = settingsLicense.getString(NexusUtilsV9.STR_VERSION, "0.0.0");
	   	int savedIsRooted = settingsLicense.getInt(NexusUtilsV9.STR_IS_ROOTING, 0);
	   	String _savedCarrier = settingsLicense.getString(NexusUtilsV9.STR_CARRIER, "0");
	   	
	   	boolean rtn = ((settingsLicense.getBoolean(NexusUtilsV9.STR_PROFILED, false) 
	   					&& app_ver.compareTo(_savedAppVersion)<1)
	   					&& ProfileDataV9.getIs_rooting() == savedIsRooted 
	   					&& NexusUtilsV9.getCarrierName(_context).equals(_savedCarrier));
	   	System.out.println("+-------------------------------");
	   	System.out.println("|	isProfileSaved STR_PROFILED = " + settingsLicense.getBoolean(NexusUtilsV9.STR_PROFILED, false));
	   	System.out.println("|	version	 " + app_ver +" : "+_savedAppVersion);
	   	System.out.println("|	rooing	 " + ProfileDataV9.getIs_rooting() +" : "+ savedIsRooted);
	   	System.out.println("|	Carrier	 " + NexusUtilsV9.getCarrierName(_context) + " : " + _savedCarrier);
	   	System.out.println("+-------------------------------");
    	return rtn;
	}
	

	public static int getGid() {
		return gid;
	}

	public static void setGid(int gid) {
		ProfileDataV9.gid = gid;
	}

	public static byte getCompany() {
		return company;
	}

	public static void setCompany(byte company) {
		ProfileDataV9.company = company;
	}

	public static byte getSale_cd() {
		return sale_cd;
	}

	public static void setSale_cd(byte sale_cd) {
		ProfileDataV9.sale_cd = sale_cd;
	}

	public static String getApp_ver() {
		return app_ver;
	}

	public static void setApp_ver(String app_ver) {
		ProfileDataV9.app_ver = app_ver;
	}



	public static byte getIs_rooting() {
		return is_rooting;
	}

	public static void setIs_rooting(byte is_rooting) {
		ProfileDataV9.is_rooting = is_rooting;
	}



//	public static byte getAccept_terms() {
//		return accept_terms;
//	}
//
//	public static void setAccept_terms(byte accept_terms) {
//		ProfileDataV9.accept_terms = accept_terms;
//	}

	
	public static String getQiipAID() {
		return qiipAID;
	}
	public static void setQiipAID(String _qiipAID) {
		qiipAID = _qiipAID;
	}	
	public static String getSktAID() {
		return sktAID;
	}
	public static void setSktAID(String _sktAID) {
		sktAID = _sktAID;
	}
	public static String getKtCID() {
		return ktCID;
	}
	public static void setKtCID(String _ktCID) {
		ktCID = _ktCID;
	}
	public static String getKtAID() {
		return ktAID;
	}
	public static void setKtAID(String _ktAID) {
		ktAID = _ktAID;
	}
	public static String getLguARMID() {
		return lguARMID;
	}
	public static void setLguARMID(String _lguARMID) {
		lguARMID = _lguARMID;
	}
	public static String getLguAppID() {
		return lguAppID;
	}
	public static void setLguAppID(String _lguAppID) {
		lguAppID = _lguAppID;
	}

	public static void setFlurryApiKey(String _apiKey)
	{
		flurryApiKey = _apiKey;
	}
	public static String getFlurryApiKey()
	{
		return flurryApiKey;
	}


}
//#endif
