/**
 * 行为CheckPoint数据模型
 */
DGC.Model.CheckPoint = $.inherits(DGC.Model,{

    id : 'model_checkpoint',



    constructor : function(config){

        //声明自定义事件
        this.defineEvents(
        );

        //API接口声明
        this.apiURL = {
            UPDATE_CHECKPOINT:{
                url: "checkpoint/update",
                pattern: /checkpoint\/update/
            }
        }

        this.keyPrev = "point_";

        DGC.Model.CheckPoint.superclass.constructor.call(this,config);
    },

    /**
     * 初始化监听数据流
     */
    registryMessages : function(){
       var MSG  = DGC.Service.Messages;
       this.service.on(MSG.UPDATE_CHECKPOINT_STATUS, this.updateCheckPointCallback, this);
    },

    /**
     * 创建Action ID
     * @param {String} pointID actionID 动作ID
     */
    createActionKey: function(pointID){
        return DGC.Common.localKey(this.keyPrev + pointID);
    },
    /**
     *设置checkpoint状态，服务器状态
     */
    updateCheckPoint:function(params){
         var DAU = DGC.ActionUtil, MSG = DGC.Service.Messages,API = this.apiURL;
         var requestBody  = {
                 msgID : MSG.UPDATE_CHECKPOINT_STATUS,
                 params: {"POST": [{url: API.UPDATE_CHECKPOINT.url,data:params}]}
             };
         DAU.requestAPI(requestBody);
    },
    /**
     *设置checkpoint状态，本地状态
     */
    updateCheckPointCallback:function(msg){
        var result = this.processResponse(msg), API = this.apiURL;
        if(result && result.success){
            var POST_RESPONSE = this.getPostResponse(result);
            for(var url in POST_RESPONSE){
                if(API.UPDATE_CHECKPOINT.pattern.test(url)){
                    this.fire("checkpointstatus");
                }
            }
        }
    }
});
