/**
 * 行为记录点模块
 */
DGC.Module.CheckPoint = $.inherits(DGC.Module, {

    baseId : 'checkpoint-tab',

    /**
     * 默认加载视图
     * @type String
     */
    deafultView: false,

    /**
     * 判断是否为根页面
     */
    isRootPage: function(){
        return true;
    },

    onInitialize : function(){

        /**
         * 视图名称枚举映射
         */
        this.viewMap = {
            v1: "SetEmail",  //设定邮箱和密码
            v2: "ModifyAvatar",  //修改用户头像
            v3: "DownloadGame",  //下载游戏
            v4: "BindSNSSina",      //绑定新浪
            v5: "BindQQ",        //绑定QQ
            v6: "BindSNSRenRen",    //绑定人人
            v7: "ShareToSina",   //分享游戏到新浪
            v8: "ShareToRenRen", //分享游戏到人人
            v9: "IntegralPay",   //积分墙
            v10: "SetPlayerName" //修改用户名
        }
        this.autoRegsiterEvents(DGC.Module.CheckPoint.EventProxy);
    }

});

/**
 * 行为记录点事件监听
 */
DGC.Module.CheckPoint.EventProxy = {
     "me":{
        "updatenickname":{
            viewName: "SetPlayerName",
            fnName: "setNameSuccess"
        },
         "updateemail":{
             viewName: "SetEmail",
             fnName: "updateEmailSuccess"
         },
         "sdkavatars":{
             viewName: "ModifyAvatar",
             fnName: "initSDKAvatar"
         },
         "updateavatar":{
             viewName: "ModifyAvatar",
             fnName: "setAvatarSuccess"
         },
         "snssharecontent":[{
             viewName:"ShareToRenRen",
             fnName: "snsContentReady"
         },{
             viewName:"ShareToSina",
             fnName: "snsContentReady"
         }],
         "snssharesuccess":[{
             viewName: "ShareToRenRen",
             fnName: "sendSNSSuccess"
         },{
              viewName: "ShareToSina",
              fnName: "sendSNSSuccess"
         }],
         "bindrenrensuccess":[{
             viewName: "ShareToRenRen",
             context: "renren",
             fnName: "loginSuccess"
         },{
             viewName: "BindSNSRenRen",
             fnName: "bindRenRen"
         }],
         "sycrenren":[{
             viewName: "ShareToRenRen",
             context: "renren",
             fnName: "sycPlayerSuccess"
         },{
             viewName: "BindSNSRenRen",
             fnName: "sycRenRen"
         }],
         "sycsina":[{
             viewName: "BindSNSSina",
             fnName: "sycSina"
         },{
             viewName: "ShareToSina",
             context: "sina",
             fnName: "sycPlayerSuccess"
         }],
         "bindsinasuccess":[{
             viewName: "BindSNSSina",
             fnName: "bindSinaSuccess"
         },{
             viewName: "ShareToSina",
             context: "sina",
             fnName: "loginSuccess"
         }],
         "bindqqsuccess":{
             viewName: "BindQQ",
             fnName: "bindQQSuccess"
         },
         "sycqq":{
             viewName: "BindQQ",
             fnName: "sycQQSuccess"
         },
         "localgamestate":{
             viewName: "DownloadGame",
             fnName: "downloadGameStatus"
         }
     },
     "pay":{
         "paymentdetail":{
             viewName: "IntegralPay",
             fnName:"cachePaymentDetail"
         },
         "cppayintegral":{
             viewName: "IntegralPay",
             fnName: "payActionResult"
         },
         "intergralclose":{
             viewName: "IntegralPay",
             fnName:"backToGame"
         }
     },
     "checkpoint":{
         "checkpointstatus":[{
             viewName:"SetPlayerName",
             fnName:"updateCheckPointSuccess"
         },{
             viewName:"SetEmail",
             fnName:"updateCheckPointSuccess"
         },{
             viewName:"DownloadGame",
             fnName:"updateCheckPointSuccess"
         },{
             viewName: "IntegralPay",
             fnName: "updateCheckPointSuccess"
         },{
             viewName: "ModifyAvatar",
             fnName: "updateCheckPointSuccess"
         },{
             viewName: "ShareToRenRen",
             fnName: "updateCheckPointSuccess"
         },{
             viewName: "BindSNSRenRen",
             fnName:"updateCheckPointSuccess"
         },{
             viewName: "BindSNSSina",
             fnName:"updateCheckPointSuccess"
         },{
             viewName: "ShareToSina",
             fnName:"updateCheckPointSuccess"
         },{
             viewName: "BindQQ",
             fnName:"updateCheckPointSuccess"
         }]
     }
}

