/**
 * "我"信息业务模型
 */
DGC.Module.Me = $.inherits(DGC.Module, {

    baseId : 'meTab',

    /**
     * 默认加载视图
     * @type String
     */
    deafultView: 'MyDetail',

    /**
     * 判断是否为根页面
     */
    isRootPage: function(){
        return (!this.hasHistoryView()
            && this.currentView.name == this.deafultView
            && this.currentView.game.id == window.sdk.game.id );
    },

    onInitialize : function(){
       //订阅model中的自定义事件
       this.autoRegsiterEvents(DGC.Module.Me.EventProxy);
       this.autoRegsiterEvents(DGC.Module.HighScores.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Achievement.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Payment.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Game.EventProxy);
       this.autoRegsiterEvents(DGC.Module.PromotionBanner.EventProxy);
    }

});

/**
 * 事件代理转发对象
 */
DGC.Module.Me.EventProxy = {
    "me":{
        //超时
        "timeout":{
            viewName: "DeveloperPromote",
            fnName: "returnToGameAction"
        },
        "updateemail":{
            viewName: "PassModify",
            fnName: "updateEmailSuccess"
        },
        "mydetail":{
            viewName: "MyDetail",
            fnName: "showMyGameInfo"
        },
        "playedgame": {
            viewName : "PlayedGames", //在指定视图时触发
            fnName : "renderPlayedGames" //调用当前视图的渲染方法
        },
        "playerfriends": [
            {
                viewName : "MyFriends",
                fnName : "renderMyFriends"
            },
            {
                viewName: "FriendsToFriends",
                fnName : "renderFriends"
            }
        ],
        "playerfollows": {
            viewName: "MyFriends",
            fnName: "renderMyFans"
        },
        "playerdetail":{
            viewName: "FriendsDetail",
            fnName: "renderPlayerDetail"
        },
        "playerrecord":{
            viewName: "GameInfo",
            fnName: "renderRecordInfo"
        },
        "searchfriends":{
            viewName: "InviteFriends",
            fnName: "renderMatchedPlayers"
        },
        "updatefriendsship":[{
            viewName: "FriendsDetail",
            fnName: "updateFriendsship"
        },{
            viewName: "InviteFriends",
            fnName: "updateFriendsship"
        }],
        "bindqqsuccess":[{
            viewName: "Setting",
            fnName: "bindQQSync"
        },{
            viewName: "AboutUs",
            fnName:"bindQQSync"
        },{
            viewName: "Dashboard",
            fnName:"bindQQSync"
        },{
            viewName: "MyFriends",
            fnName: "bindQQSync"
        }],
        "unbindqqsuccess":{
            viewName: "Setting",
            fnName: "updateQQBind"
        },
        "sendqqachieve":{
            viewName: "Setting",
            fnName: "updateQQAchieveStatus"
        },
        "sycqq":[{
            viewName: "Setting",
            fnName: "updateQQSyncResult"
        },{
            viewName: "AboutUs",
            fnName:"updateQQSyncResult"
        },{
            viewName: "Dashboard",
            fnName:"updateQQSyncResult"
        },{
            viewName: "MyFriends",
            fnName: "updateQQSyncResult"
        }],
        "bindsinasuccess":[{
            viewName: "Setting",
            context: "sina",
            fnName: "loginSuccess"
        },{
            viewName: "AboutUs",
            context: "sina",
            fnName: "loginSuccess"
        },{
            viewName: "Dashboard",
            context: "sina",
            fnName: "loginSuccess"
        },{
            viewName: "MyFriends",
            context: "sina",
            fnName: "loginSuccess"
        },{
            viewName: "BindSina",
            context: "sina",
            fnName: "loginSuccess"
        }],
        "unbindsinasuccess":{
            viewName: "Setting",
            fnName: "updateSinaBind"
        },
        "sendsinaachieve":{
            viewName: "Setting",
            fnName: "updateSinaAchieveStatus"
        },
        "sycsina":[{
            viewName: "Setting",
            context: "sina",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "AboutUs",
            context: "sina",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "Dashboard",
            context: "sina",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "MyFriends",
            context: "sina",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "BindSina",
            context: "sina",
            fnName: "sycPlayerSuccess"
        }],
        "bindrenrensuccess":[{
            viewName: "Setting",
            context: "renren",
            fnName: "loginSuccess"
        },{
            viewName: "AboutUs",
            context: "renren",
            fnName: "loginSuccess"
        },{
            viewName: "Dashboard",
            context: "renren",
            fnName: "loginSuccess"
        },{
            viewName: "MyFriends",
            context: "renren",
            fnName: "loginSuccess"
        }],
        "unbindrenrensuccess":{
            viewName: "Setting",
            fnName: "updateRenrenBind"
        },
        "sycrenren":[{
            viewName: "Setting",
            context: "renren",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "AboutUs",
            context: "renren",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "Dashboard",
            context: "renren",
            fnName: "sycPlayerSuccess"
        },{
            viewName: "MyFriends",
            context: "renren",
            fnName: "sycPlayerSuccess"
        }],
        "sendrenrenachieve":{
            viewName:"Setting",
            fnName:"updateRenRenAchieveStatus"
        },
        "tipsready":{
            viewName: "MyDetail",
            fnName: "updateMyNewFriends"
        },
        "updatemydetail":[{
            viewName: "MyDetail",
            fnName: "updatePlayerDetail"
        },{
            viewName:"Setting",
            fnName: "updatePlayerDetail"
        }],
        'updateloginplayer':{
            viewName: "MyDetail",
            fnName: "updatePlayerInfo"
        },

        //SDK1.2
        'selectavatarway':[{
            viewName: "Setting",
            fnName: "avatarWaySelected"
        },{
            viewName: "MyDetail",
            fnName: "avatarWaySelected"
        }],
        'updateavatar':[{
            viewName: "Setting",
            fnName: "updatePlayerAvatar"
        },{
            viewName: "MyDetail",
            fnName: "updatePlayerAvatar"
        } ],
        'updatenickname':[{
            viewName: "Setting",
            fnName: "updatePlayerName"
        },{
            viewName: "MyDetail",
            fnName: "updatePlayerName"
        }],
        'updategender':{
            viewName: "Setting",
            fnName: "updatePlayerGender"
        },
        'feedback': {
            viewName: "AboutUs",
            fnName: "feedBackSuccess"
        },
        'clearaccountsuccess':{
            viewName: "Setting",
            fnName: "useNewAccount"
        },
        "latestactivity": {
            viewName: "Activity",
            fnName: "renderLatestActivity"
        },
        "circuseeactivity": {
            viewName: "Activity",
            fnName: "renderCircuseeActivity"
        },
        "updatecircuseeactivity":{
            viewName: "Activity",
            fnName: "updateCircuseeActivity"
        },
        "handlePromoteCode":[{
            viewName: "PromoteCode",
            fnName: "handlePromoteCode"
        },{
            viewName: "DeveloperPromote",
            fnName: "handlePromoteCode"
        }],
        "localgamestate":[{
            viewName: "PromoteCode",
            fnName: "showGameStatus"
        },{
            viewName: "DeveloperPromote",
            fnName: "showGameStatus"
        }],
        "snssharecontent":[{
            viewName: "AboutUs",
            context: "shareWin",
            fnName: "contentReady"
        },{
            viewName: "Dashboard",
            context: "shareWin",
            fnName: "contentReady"
        },{
            viewName: "MyFriends",
            context: "shareWin",
            fnName: "contentReady"
        }],
        "snssharesuccess":[{
            viewName:"AboutUs",
            context: "shareWin",
            fnName: "sendSNSSuccess"
        },{
            viewName: "Dashboard",
            context: "shareWin",
            fnName: "sendSNSSuccess"
        },{
            viewName: "MyFriends",
            context: "shareWin",
            fnName: "sendSNSSuccess"
        }],
        "sdkavatars":[{
            viewName: "MyDetail",
            fnName: "showChangeAvatar"
        },{
            viewName: "Setting",
            fnName: "showChangeAvatar"
        }],
        "preloadavatar":{
            viewName: "MyDetail",
            fnName: "preLoadAvatars"
        }
    }
}
