/**
 * 修改头像
 */
DGC.Dialog.ChangeAvatar = $.inherits(DGC.Dialog, {

    baseId : 'change-avatar',

    renderTpl : '1.4.0/js/template/dialog/changeavatar.html',

    /**
     * SDK头像信息
     */
    sdkAvatars: undefined,

    avatarRefresh: false,

    viewReady : function() {
        this.loadSDKAvatar();
        this.showSNSAvatar();
        this.bindLocalAvatar();

        //点亮当期头像
        this.hightLightAvatar();

        //关闭按钮
        this.el.find(".dailog-close-btn").bind(DGC.Common.E_TAP_DOWN, DGC.Common.buttonTapDownHandler)
            .bind(DGC.Common.E_TAP_UP, DGC.Common.buttonTapEndHandler)
            .bind('tap',{context: this}, function(event){
                var context = event.data.context;
                context.destory();
            });

    },

    /**
     * 加载SDK推荐头像
     */
    loadSDKAvatar: function(){
        var cacheAvatars = this.sdkAvatars;
            avatarWraps  = this.el.find('.default-avatar-content .icon-wrap'),
            loadIcons = [];

        //设置头像KEY
        for(var i = 0; i < cacheAvatars.length ; i++ ){
            var cacheAvatar =  cacheAvatars[i],
                wrap = avatarWraps.get(i);
                imgObj = { url: cacheAvatar.icon , key: cacheAvatar.icon };

            if(this.avatarRefresh){
                $.extend(imgObj, { expire: 1 /*即时过期*/ });
            }
            loadIcons.push(imgObj);
            $(wrap).attr('data-key', cacheAvatar.icon);
            $(wrap).bind('tap', { context: this, key : cacheAvatar.icon}, function(event){
                var key = event.data.key,
                    context = event.data.context;
                if(context.isSameAvatar(key)){
                    context.destory();
                }else{
                    context.meModel.updateAvatarUrl(key);
                }
            });
        }

        //动态加载头像
        this.parentView.loadImages(loadIcons, this.repalceAvatar );
    },

    /**
     * 显示当前绑定过的SNS
     */
    showSNSAvatar : function(){
        var ATTR = DH.ATTR ,
            context = this,
            loadIcons = [],
            avatarEl;

        if(!DH.isAnySNSBound()) return false;

        //任意SNS绑定
        if(DH.isSNSBound(ATTR.BIND_KEY.QQ)){
            avatarEl = this.el.find('.qq-avatar');
            avatarEl.attr('data-key', window.sdk.tencent.avatar);
            loadIcons.push({ url: window.sdk.tencent.avatar , key: window.sdk.tencent.avatar });
            avatarEl.bind('tap',function(){
                if(context.isSameAvatar(window.sdk.tencent.avatar)){
                    context.destory();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.QQ, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }

        if(DH.isSNSBound(ATTR.BIND_KEY.SINA)){
            avatarEl = this.el.find('.sina-avatar');
            avatarEl.attr('data-key', window.sdk.sina.avatar);
            loadIcons.push({ url: window.sdk.sina.avatar , key: window.sdk.sina.avatar });
            avatarEl.bind('tap', function(){
                if(context.isSameAvatar(window.sdk.sina.avatar)){
                    context.destory();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.SINA, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }

        if(DH.isSNSBound(ATTR.BIND_KEY.RENREN)){
            avatarEl = this.el.find('.renren-avatar');
            avatarEl.attr('data-key', window.sdk.renren.avatar);
            loadIcons.push({ url: window.sdk.renren.avatar , key: window.sdk.renren.avatar });
            avatarEl.bind('tap', function(){
                if(context.isSameAvatar(window.sdk.renren.avatar)){
                    context.destory();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.RENREN, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }

        this.el.find('.sns-avatar-content').show();

        if(loadIcons.length > 0){
            this.parentView.loadImages(loadIcons, this.repalceAvatar );
        }
    },

    /**
     *  验证是否为相同头像
     */
    isSameAvatar : function(avatar) {
        return (avatar == window.sdk.player.avatar_url);
    },

    /**
     * 绑定本地头像
     */
    bindLocalAvatar : function(){
        var DAU = DGC.ActionUtil,
            AVATAR = DH.ATTR.UPDATE_AVATAR;

        //本地相册
        this.el.find('.local-avatar').bind('tap',function(){
            DAU.updateAvatar(AVATAR.LOCAL);
        });

        //拍照
        this.el.find('.camera-avatar').bind('tap',function(){
            DAU.updateAvatar(AVATAR.CAMERA);
        });
    },

    /**
     * 点亮当前头像
     */
    hightLightAvatar : function(){
        var avatar_url = window.sdk.player.avatar_url,
            sdkAvatars = this.sdkAvatars;

        if($.isEmpty(avatar_url)) return false; //头像为空，不点亮

        var avatarEl = this.el.find(".icon-wrap[data-key='"+ avatar_url +"']");
        if(avatarEl.size() >  0 ){
            avatarEl.find(".mask").addClass('active');
        }else{
            avatarEl =  this.el.find(".user-avatar");
            avatarEl.attr("data-key", avatar_url);
            avatarEl.show();
            //动态加载头像
            this.parentView.loadImages({ url: avatar_url, key: avatar_url}, this.repalceAvatar);
        }
    },

    /**
     * 替换动态头像
     */
    repalceAvatar : function(img, data){
        var wrap = $(".icon-wrap[data-key='"+ data.key +"']");
        wrap.find('.default-icon').replaceWith("<img src='"+ img.src +"'></img>");
    }

});