/**
 * 本地游戏信息
 */
DGC.View.AboutUs =  $.inherits(DGC.View, {

    baseId: 'myaboutus-view',

    title: 'A_TITLE_ABOUT_US',

    renderTpl:'1.4.0/js/template/aboutus.html',

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.el.find(".btn").bind(DGC.Common.E_TAP_DOWN, DGC.Common.buttonTapDownHandler)
            .bind(DGC.Common.E_TAP_UP, DGC.Common.buttonTapEndHandler);

        $(".aboutus-version span.value").text($.format("v{0} build({1})",[ window.sdk.version , window.sdk.svn_version]));

        //分享
        $("#share-game-btn").bind('tap',{context: this},function(event){
            var context = event.data.context;

            //记录点：“关于我们”界面，点击 “分享”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_SETTINGS_ABOUT_US_SHARE,
                {
                    'user_id': window.sdk.player.id
                }
            );

            //弹出分享窗口
            context.action.showDialog(
                "ShareGame",
                {
                    meModel: context.action.model['me'],
                    notBindCallback : $.bindFn(context.bindAccount, context) //没有sns绑定帐号执行
                },
                function(name, params){
                    //弹出绑定的Dialog
                    this.shareWin = new DGC.Dialog[name](params);
                    this.shareWin.show();
                },
                context
            );
        });

        //反馈
        $("#feedback-btn").bind("tap", { context: this }, function(event){
            var context = event.data.context;

            //记录点：“关于我们”界面，点击 “反馈”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_SETTINGS_FEEDBACK,
                {
                    'user_id': window.sdk.player.id
                }
            );

            context.feedback = new DGC.Dialog.FeedBack({
                meModel: context.action.model['me']
            });
            context.feedback.show();
        });

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_SETTINGS_ABOUT);
    },

    /**
     * 意见反馈
     */
    feedBackSuccess: function(){
        //意见反馈
        if(this.feedback){
            DGC.ActionUtil.showTipMsg(resName.TIP_SUBMIT_SUCCESS);
            this.feedback.destory();
            this.feedback = null;
        }
    },

    /**
     * 绑定SNS帐号
     */
    bindAccount: function(type, isExpired){
        var ATTR = DH.ATTR;
        if (type == ATTR.BIND_SNS.SINA){
            this.action.showDialog(
                    "SinaDialog",
                    {
                        meModel: this.action.model['me'],
                        relogin : isExpired
                    },
                    function(name, params){
                        //注册事件分发回调
                        $.extend(DGC.View.AboutUs.prototype, DGC.Dialog[name].Proxy);

                        //弹出绑定的Dialog
                        this.sina = new DGC.Dialog[name](params);
                        this.sina.show();
                    },
                    this);
        } else if (type == ATTR.BIND_SNS.RENREN){
            this.action.showDialog(
                    "RenRenLoginDialog",
                    {
                        meModel: this.action.model['me'],
                        relogin : isExpired
                    },
                    function(name, params){
                        //注册事件分发回调
                        $.extend(DGC.View.AboutUs.prototype, DGC.Dialog[name].Proxy);

                        //弹出绑定的Dialog
                        this.renren = new DGC.Dialog[name](params);
                        this.renren.show();
                    },
                    this);
        } else if( type == ATTR.BIND_SNS.QQ){
            //跳转QQ绑定页面
            this.action.model['me'].updateBindSNS(ATTR.BIND_SNS.QQ);
        }
    },

    /**
     * 绑定QQ成功后，导入QQ相关信息
     */
    bindQQSync: function(){
         var ATTR = DH.ATTR;
         //同步QQ信息
         this.action.model['me'].snsSycPlayer(ATTR.SYNC_SNS.QQ, ATTR.SYNC_TYPE.ALL);
    },

    /**
     * 同步QQ信息结果
     */
    updateQQSyncResult: function(result){
        var tipMsg = result ? resName.TIP_BIND_SUCCESS : resName.TIP_SYNCHRONIZED_FAIL;
        DGC.ActionUtil.showTipMsg(tipMsg);
    },

    /**
     * 视图销毁时，移除事件监听
     */
    onDestory : function(){
        if(this.shareWin){
             this.shareWin.destory();
             this.shareWin = null;
        }
        if(this.renren){
            this.renren.destory();
            this.renren = null;
        }
        if(this.sina){
            this.sina.destory();
            this.sina = null;
        }
    }

});

/**
 * 意见反馈窗口
 */
DGC.Dialog.FeedBack = $.inherits(DGC.Dialog, {

    baseId: 'feedback-dialog',

    renderTpl:'1.4.0/js/template/dialog/feedback.html',

    viewReady: function(){
        this.el.find(".btn").bind(DGC.Common.E_TAP_DOWN, DGC.Common.buttonTapDownHandler)
            .bind(DGC.Common.E_TAP_UP, DGC.Common.buttonTapEndHandler);

        //确认按钮
        this.el.find(".btn-ok").bind("tap", { context: this }, function(event){
            var context = event.data.context,
                textarea = context.el.find('.feed-text').val();

            //反馈内容不为空
            if($.isEmpty(textarea)){
                DGC.ActionUtil.showTipMsg(resName.TIP_FEED_BACK_AREA);
                return false;
            }

            //提交给feed处理
            context.meModel.queryFeedBack(textarea);
        });

        //取消按钮
        this.el.find(".btn-cancel").bind("tap",{ context: this }, function(event){
            var context = event.data.context;
            setTimeout( $.bindFn(context.destory, context) , 500 );
        });
    }
});
