/**
 * 充值模式选择
 */
DGC.View.ChargeAccount =  $.inherits(DGC.View, {

    baseId: 'charge-account-view',

    renderTpl:'1.4.0/js/template/chargeaccount.html',

    paymentWays: undefined,

    /**
     * 支付道具信息(仅支付时需要)
     */
    orderInfo: undefined,

    /**
     * 入口模式
     * 0:充值入口
     * 1:游戏开发者入口
     * 2:道具商城入口
     */
    chargeModel: 0,

    /**
     * 是否只有一种支付方式
     */
    onlyPay: false,

    /**
     * 道具类型自定义道具类型
     * @type Number
     */
    type: 0,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.viewTpl = {
            CHARGEWAY: "#chargeway-tpl",
            LEDOU_REMAIN:"#account-remain-tpl",
            RECENT_CHARGE:"#recent-charge-tpl",
            ITEM_CHARGE:"#item-detail-tpl",
            ITEM_HISTORY: '#item-history-tpl',
            ITEM_HISTORY_ICON: '#item-history-icon-tpl',
            ITEM_CONTENT: '#item-history-content-tpl',
            ITEM_GAME_CHARGE: '#item-history-game-tpl'
        }

        switch(this.chargeModel){
            case 0/*充值 */:
                this.setTitle(resName.A_TITLE_CHARGE_ACCOUNT);
                this.action.model['pay'].queryChargeList(0/*充值*/);
                //查询用户余额和最后一次交易记录(不支付乐币，不查询交易记录)
                if(window.sdk.channel.enable_coin_payment){
                    this.action.model['pay'].queryPlayerCoins(true, true);
                    $("#charge-account").addClass('coins-charge-history'); //充值列表
                }
                //SKYNET_PAGE_ME_PAYMENT

                //记录页面访问次数
                DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_PAYMENT);
                break;
            case 1/*游戏开发者*/:
                /*游戏入口则默认视图*/
                //this.setBackEnable(false);
                //this.setTitle(resName.A_TITLE_PAY_ACCOUNT);
                //查询购买道具信息
                //this.action.model['pay'].queryBuyItemDetail();
                //this.action.model['pay'].queryChargeList(1/*支付*/);
                //break;
            case 2/*道具商城*/:
                this.setTitle(resName.A_TITLE_PAY_ACCOUNT);
                this.action.model['pay'].queryChargeList(1/*支付*/);
                $("#charge-account").addClass('buy-item-list'); //表示支付列表
                //自适应Order对象
                this.basicOrder = this.action.model['pay'].getBasicOrder(this.type, this.orderInfo);

                //购买道具栏信息(当前只支持一个道具)
                this.el.prepend(this.renderByTpl(this.viewTpl.ITEM_CHARGE, {
                    productName: this.basicOrder.name,
                    needPayCoins: DGC.Common.currencyFormat( this.orderInfo.quantity * this.basicOrder.price, 2 ),
                    hasCoins: window.sdk.player.coins,
                    icon: this.basicOrder.icon
                }));

                //记录页面访问次数
                DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_MALL_PURCHASE);
                break;
        }
    },

    /**
     * 渲染当前用户信息
     * @param {Number} coins 余额
     * @param {Arrary} history 最近支付记录()
     */
    renderPlayerCoins: function(coins, history){
        var listDom = $("#charge-account"),
            DC = DGC.Common;

        window.sdk.player.coins = coins;

        //显示余额
        var remainEl = $(this.renderByTpl(this.viewTpl.LEDOU_REMAIN,{coins: window.sdk.player.coins}));
        //查看交易记录
        remainEl.find(".charge-history")
            .bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this } , function(event){
                //“充值”界面，点击 “查询交易纪录”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_PAYMENT_LIST,
                    {
                        'user_id':window.sdk.player.id
                    }
                );
                var context = event.data.context;
                context.action.setView("ChargeHistory");
        });

        listDom.before(remainEl);

        //显示最近充值记录
        if(history.length > 0){
            var record = history[0];
            $.extend(record,{
                detailHtml: this.getHistoryHtml(record),
                time: DC.getFormatDate(DC.getDateFromTime(record.datetime), true )
            })

            listDom.after(this.renderByTpl(this.viewTpl.RECENT_CHARGE, record));

            //延迟加载最近买道具记录图标
            switch(record.type){
                case 0 /*乐币买道具*/:
                case 2 /*RMB买道具*/:
                case 4 /*兑换码兑换道具*/:
                case 6 /*积分买道具*/:
                    if(!$.isEmpty(record.product_icon)){
                        this.loadImages({ url: record.product_icon },function(img, data){
                            var imgWrap  = $(".foot-bar .content .icon");
                            imgWrap.find(".default-icon").replaceWith("<img src='" + img.src +"'><div class='mask'></div>");
                        });
                    }
                    break;
                default:
                    break;
            }
        }
    },

    /**
     * 历史记录结构
     */
    getHistoryHtml: function(record){
        var html = '';
        switch(record.type){
             case 0 /*乐币买道具*/:
             case 10 /*乐币购买CheckPoint*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_BUY ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY
                 });
                break;
            case 1 /*充值乐币*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY, {
                     label: resName.TEXT_CHARGEHISTORY_CHARGE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_RMB
                });
                break;
            case 2 /*RMB买道具*/:
            case 9 /*RMB购买CheckPoint*/:
            case 12 /*RMB购买CheckPoint group*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_BUY ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_RMB
                 });
                break;
            case 4 /*兑换码兑换道具*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_CONTENT, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_EX_ITEM
                 });
                break;
            case 5 /*兑换码兑换乐币*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY, {
                     label: resName.TEXT_CHARGEHISTORY_EXCHANGE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY
                });
                break;
            case 6 /*积分买道具*/:
            case 11 /*积分买CheckPoint*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_USE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_INTEGRAL
                });
                break;
            case 8 /*购买第三方虚拟货币*/:
               html = this.renderByTpl(this.viewTpl.ITEM_GAME_CHARGE,{
                     label: resName.TEXT_CHARGEHISTORY_CHARGE,
                     game_name: record.product_name /*游戏名称*/,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_RMB
               });
               break;

        }

        return html;
    },


    /**
     * 支付列表动态渲染
     */
    renderChargeList : function(chargelist){

        //仅一种支付方式,直接进入相关模式, 不支持乐币则自动跳转
        if(chargelist.length  == 1 /*只支持一种支付模式*/  && !DH.isSupportCoins() ){

           this.onlyPay = true; /*只有一种支付方式*/
           this.chooseChargeOrPay(chargelist[0]);

        //多种支付方式
        }else{
            var key = "";
            //判断充值还是支付模式
            switch(this.chargeModel){
                case 0 /*充值*/:
                    key = "chargeway";
                    break;
                case 1:
                case 2:/*支付*/
                    key = "payway";
                    break;
            }

            //键值
            var identifier = window.sdk.config_params[DGC.Common.localKey(key)];

            //最近记录键值
            if(identifier){
                for (var i = 0; i  < chargelist.length; i ++) {
                    var charge = chargelist[i];
                    if(charge.identifier == identifier){
                        chargelist.splice( i , 1); //先移除匹配的支付方式
                        chargelist = [charge].concat(chargelist); //重新生成支付方式列表
                        break;
                    }
                };
            }

            var items = $(this.renderByTpl(this.viewTpl.CHARGEWAY, chargelist));

            items.bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                .bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                .bind('tap', { context: this }, this.showChargeWayDetail);

            this.el.find('.chargeway-list').append(items);
            $("#charge-account").show();

            this.loadImages( this.getDelayIcons(chargelist) ,function(img, data){
                var imgWrap  = $(".list-item[data-key='"+ data.identifier +"']");
                imgWrap.find(".default-icon").replaceWith("<img src='"+ img.src + "'></img>");
            });

            //缓存支付列表
            this.paymentWays = chargelist;
        }

    },

    /**
     * 获取需要延迟加载的图标信息
     */
    getDelayIcons : function(charges){
        var delays = [];

        //delayIcons
        for (var i = 0; i < charges.length; i++) {
            var charge = charges[i];
            if(!$.isEmpty(charge.icon)){
                delays.push({
                    url: charge.icon,
                    identifier: charge.identifier
                });
            }
        };

        return delays;
    },

    /**
     * 切换至具体支付页面
     */
    showChargeWayDetail: function(event){
       var context = event.data.context,
           key = $(this).attr("data-key"),
           paymentWay;

       //查找当前点击支付方式
       for (var i = 0; i < context.paymentWays.length; i++) {
           paymentWay = context.paymentWays[i];
           if(paymentWay.identifier == key){
              break;
           }
       };

       context.chooseChargeOrPay(paymentWay);
    },


    /**
     * 根据当期模式选择充值或支付方式
     */
    chooseChargeOrPay: function(paymentWay){
       var obj = {};

       //充值模式
       if(this.chargeModel == 0 /*充值*/){

           //充值乐币”界面，点击具体的支付方式
           DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_PAYMENT_CHARGE_ACTION,
                {
                    'user_id': window.sdk.player.id,
                    'charge_channel': DGC.Event.Util.getPayEvent(paymentWay.identifier)
                }
           );
           //记录最近充值方式
           obj[DGC.Common.localKey('chargeway')] = paymentWay.identifier;

           //充值始终进入金额选择页面
           this.action.setView('ChargeCommit',{
               payWay: paymentWay,
               onlyPay: this.onlyPay
           });
       //支付模式
       }else{
          //记录最近支付方式
          obj[DGC.Common.localKey('payway')] = paymentWay.identifier;
          this.callDetailPayMethod(paymentWay);
       }

       DGC.ActionUtil.setConfigParams(obj);
    },

    /**
     * 根据支付方式和道具类型不同，跳转至不同界面
     */
    callDetailPayMethod: function(paymentWay){
        //支付金额
        var payModel = this.action.model['pay'];

        var actionObj = {
            'user_id': window.sdk.player.id,
            'game_id': window.sdk.game.id,
            'purchase_channel': DGC.Event.Util.getPayEvent(paymentWay.identifier)
        };

        switch(this.type){
            case 0 /*道具*/:
                $.extend(actionObj, { 'product_id': this.basicOrder.id });
                break;
            case 1 /*CheckPoint*/:
                $.extend(actionObj, { 'cp_id': this.basicOrder.id });
                break;
            case 2 /*CheckPoint Group*/:
                $.extend(actionObj, { 'cp_group_id': this.basicOrder.id });
                break;
        }

        //“支付道具”界面，点击具体某一个支付渠道
        DGC.ActionUtil.recordUserAction( DGC.Event.EventId.EVENT_MALL_PURCHASE_CHANNEL_ACTION, actionObj);

        /*易宝支付页面需要进入金额选择页面*/
        if(payModel.isYeepay(paymentWay.identifier)){
            this.action.setView("PayCommit",{
                 payWay: paymentWay,
                 orderInfo: this.orderInfo,
                 onlyPay: this.onlyPay,
                 type: this.type
            });
        }else{
            payModel.executePay( payModel.mapServerPay(this.type), {
                orderInfo: this.orderInfo,
                paymethod: paymentWay.identifier,
                recharge: DGC.Common.currencyFormat(this.orderInfo.quantity * this.basicOrder.price * paymentWay.rate * paymentWay.discount , 2),
                product_type: this.type
            });
        }
    },

    /**
     * 支付宝/财付通支付结果回调
     * @param {Boolean} result 充值结果
     * @param {object} detail 支付方式以及提示
     * @param {Object} failitem 支付失败的item对象
     */
    payByAliResult: function(result, detail , failitem){
        if(detail.paymethod == 6 /*支付宝*/ || detail.paymethod == 23 /*财付通*/ ){
            this.action.model['pay'].payOrderNotify( 3 /*支付宝/易宝*/ , result, detail , failitem, function(){
                DGC.ActionUtil.openWebView(detail.payment_url, true);
            });
        }
    },

    /**
     * 本地支付后结果回调(短代,机锋)
     */
    payByLocalResult: function(result, detail){
        $.extend(detail, { item_name : this.basicOrder.name} ); //道具名称
        //跳转显示充值结果
        this.action.setView("PayResult",{
            result: result,
            payInfo: detail
        }, false/*非重置*/, this.onlyPay /*不保存当前视图*/);
    },

    /**
     * 支付宝/财付通支付CheckPoint结果回调
     */
    payCPByAliResult:function(result, detail , failitem){
        if(detail.paymethod == 6 /*支付宝*/ || detail.paymethod == 23 /*财付通*/ ){
            this.action.model['pay'].payOrderNotify( 9 /*支付宝/易宝CheckPoint*/ , result, detail , failitem, function(){
                DGC.ActionUtil.openWebView(detail.payment_url, true);
            });
        }
    },

    /**
     * 支付宝/财付通支付CheckPoint Group结果回调
     */
    payCPGByAliResult:function(result, detail , failitem){
        if(detail.paymethod == 6 /*支付宝*/ || detail.paymethod == 23 /*财付通*/ ){
            this.action.model['pay'].payOrderNotify( 12 /*支付宝/易宝CheckPoint Group*/ , result, detail , failitem, function(){
                DGC.ActionUtil.openWebView(detail.payment_url, true);
            });
        }
    }

});