/**
 * 设置/修改密码
 */
DGC.View.PassModify =  $.inherits(DGC.View, {

    baseId: 'pass-modify-view',

    title: 'A_TITLE_PASS_MODIFY',

    renderTpl:'1.4.0/js/template/passmodify.html',

    /**
     * 密码修改模式
     * 枚举：
     * 0:设置密码
     * 1:修改密码
     */
    modifyModel: 0, //默认设置密码

    /**
     * 视图初始化函数
     */
    viewReady: function(){
         var ATTRS = DGC.View.PassModify.ATTRS ,
              memuTitle, formTpl;

        this.modifyModel = ( DH.isPasswordSet() ? ATTRS.MODIFY_MODEL.MODIFY /*已绑定*/ : ATTRS.MODIFY_MODEL.SET /*未绑定*/ );
        switch(this.modifyModel){
            case ATTRS.MODIFY_MODEL.SET:
                memuTitle = resName.TITLE_PASSMODIFY_SETTTING_PASS;
                formTpl = $("#set-pass-tpl");
                break;
            case ATTRS.MODIFY_MODEL.MODIFY:
                memuTitle = resName.TITLE_PASSMODIFY_MODIFY_PASS;
                formTpl = $("#modify-pass-tpl");
                break;
        }

        $("#pm-modify-title").text(memuTitle);
        $("#pass-modify").prepend(formTpl.html());

        //提示原手机号
        if(this.modifyModel == ATTRS.MODIFY_MODEL.MODIFY){
            $("#modify-email").attr("placeholder", window.sdk.player.email);
        }

        $("#pass-modify").bind('submit',{context:this},function(event){
            var context = event.data.context,
                emailReg = /\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/;

            switch(context.modifyModel){
                case ATTRS.MODIFY_MODEL.SET:
                    var email = $("#set-email").val(),
                        password = $("#set-password").val(),
                        confirm = $("#set-confirm").val();

                    //邮箱地址不为空
                    if($.isEmpty(email)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_EMAIL_NOT_EMPTY);
                        return false;
                    }

                    //邮箱格式不正确
                    if(!emailReg.test(email)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_EMAIL_ERROR_FORMAT);
                        return false;
                    }

                    //密码不为空
                    if($.isEmpty(password)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD);
                        return false;
                    }

                    //确认密码不为空
                    if($.isEmpty(confirm)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_CONFIRM);
                        return false;
                    }

                    //两次密码不一致
                    if(password!=confirm){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD_CONFIRM);
                        return false;
                    }

                    //提交给feed处理
                    context.action.model['me'].updateSetPass(email , password);
                    break;
                case ATTRS.MODIFY_MODEL.MODIFY:
                    var oldpassword = $("#modify-old-password").val(),
                        newpassword = $("#modify-new-password").val(),
                        confirm = $("#modify-confirm").val(),
                        email = $("#modify-email").val();

                    //旧密码不为空
                    if($.isEmpty(oldpassword)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_OLD_PASSWORD);
                        return false;
                    }

                    //新密码不为空
                    if($.isEmpty(newpassword)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_NEW_PASSWORD);
                        return false;
                    }

                    //确认密码不为空
                    if($.isEmpty(confirm)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_CONFIRM);
                        return false;
                    }

                    //两次密码不一致
                    if(newpassword != confirm){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_PASSWORD_CONFIRM);
                        return false;
                    }

                    //判断是否有修改邮箱地址
                    if(!$.isEmpty(email) && email != window.sdk.player.email){
                        //邮箱地址不正确
                        if(!emailReg.test(email)){
                            DGC.ActionUtil.showTipMsg(resName.TIP_SET_EMAIL_ERROR_FORMAT);
                            return false;
                        }

                        DGC.Common.confirm(resName.TIP_PASSMODIFY_EMAIL_CONFIRM_TITLE, $.format(resName.TIP_PASSMODIFY_EMAIL_CONFIRM_MSG, [email]), function(result) {
                            if(result) {
                                context.action.model['me'].updateModifyPass({
                                    "old_password" : oldpassword,
                                    "new_password" : newpassword,
                                    "email" : email
                                });
                            }
                        });
                    }else{
                        //提交给feed处理
                        context.action.model['me'].updateModifyPass({
                            "old_password": oldpassword,
                            "new_password": newpassword
                        });
                    }
                    break;
            }
            return false;
        });

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_ACCOUNT);

    },

    /**
     * 保存成功后的行为
     */
    updateEmailSuccess:function(){
         DGC.ActionUtil.showTipMsg(resName.TIP_SAVE_SUCCESS, function(){
             DGC.Application.goBack();
         });
    }
});

DGC.View.PassModify.ATTRS = {

    MODIFY_MODEL: {

        SET: 0,

        MODIFY: 1
    }
}

