/**
 * 设定
 */
DGC.View.Setting =  $.inherits(DGC.View, {

    baseId: 'mysetting-view',

    title: 'A_TITLE_SETTING',

    renderTpl:'1.4.0/js/template/setting.html',

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        /**
         * 绑定描述
         */
        this.bindSNSString = {
            SINA : {
                BIND_TEXT: resName.TEXT_SETTING_SINA_BIND_TEXT,
                BIND_DESC: resName.TEXT_SETTING_SINA_BIND_DESC ,
                BOUND_TEXT: resName.TEXT_SETTING_SINA_BOUND_TEXT
            },
            RENREN : {
                BIND_TEXT: resName.TEXT_SETTING_RENREN_BIND_TEXT ,
                BIND_DESC: resName.TEXT_SETTING_RENREN_BIND_DESC ,
                BOUND_TEXT: resName.TEXT_SETTING_RENREN_BOUND_TEXT
            },
            QQ: {
                BIND_TEXT: resName.TEXT_SETTING_QQ_BIND_TEXT ,
                BIND_DESC: resName.TEXT_SETTING_QQ_BIND_DESC ,
                BOUND_TEXT: resName.TEXT_SETTING_QQ_BOUND_TEXT
            }
        }

        this.setPlayerInfo();
    },

    /**
     * 更新界面上的头像
     */
    updatePlayerAvatar: function(){
        //判断用户头像是否缺省头像
        var iconWrap = this.el.find(".icon");
        //自定义头像
        if(!$.isEmpty(window.sdk.player.avatar_url)){
            iconWrap.html($.format('<img id="player-avatar" src="{0}"/><div class="mask"></div>', [window.sdk.player.avatar_url]));
        }else{
            iconWrap.html('<div class="default-icon"></div>');
        }

        if(this.avatarWin){
            this.avatarWin.destory();
            this.avatarWin = null;
        }
    },

    /**
     * 更新玩家昵称
     */
    updatePlayerName : function(){
        var modify = $("#modify-name");
        //昵称
        this.el.find(".name").text( window.sdk.player.nickname );
        modify.attr("placeholder", window.sdk.player.nickname );
        modify.val(""); //清空内容
    },

    /**
     * 更新当前用户的信息(绑定->替换昵称和头像,性别)
     */
    updatePlayerDetail : function(){
        this.updatePlayerName();
        this.updatePlayerAvatar();
        this.updatePlayerGender();
    },

    /**
     * 更新玩家性别
     */
    updatePlayerGender : function(){
        var ATTR = DH.ATTR,
            genderClass = "",
            sexIconEl = this.el.find(".sex-icon");;

        this.el.find(".sex-btn-wrap > div").removeClass('active');

        //性别
        switch(window.sdk.player.gender){
            case ATTR.GENDER.SECRET:
                return false; /*保密不显示*/
            case ATTR.GENDER.MALE:
                genderClass = 'male';
                break;
            case ATTR.GENDER.FEMALE:
                genderClass = 'female';
                break;
        }
        sexIconEl.removeClass('female male');
        this.el.find(".sex-icon").addClass(genderClass);
        this.el.find(".sex-btn-wrap "+"." + genderClass).addClass('active');
    },

    /**
     * 绑定QQ成功后，导入QQ相关信息
     */
    bindQQSync: function(){
         var ATTR = DH.ATTR;
         //同步QQ信息
         this.action.model['me'].snsSycPlayer(ATTR.SYNC_SNS.QQ, ATTR.SYNC_TYPE.ALL);
    },

    /**
     * 同步QQ信息结果
     */
    updateQQSyncResult: function(result){
        var tipMsg = result ? resName.TIP_BIND_SUCCESS : resName.TIP_SYNCHRONIZED_FAIL;
        DGC.ActionUtil.showTipMsg(tipMsg, $.bindFn(this.updateQQBind, this));
    },

    /**
     * 更新腾讯绑定状态
     */
    updateQQBind : function(){
        var qqBindEl =  $("#qq-bind"),
            qqAchieveEl = $("#qq-sendachieve"),
            qqBindBtn = $("#qq-bind-btn"),
            qqHlEl = this.el.find(".qq-hightlight");

        if(DH.isSNSBound(DH.ATTR.BIND_KEY.QQ)){
            qqBindEl.find("h1").text(this.bindSNSString.QQ.BOUND_TEXT);
            qqBindEl.find("h2").html(window.sdk.tencent.name);
            qqBindBtn.text(resName.BUTTON_SETTING_CANCEL_BIND);
            this.updateQQAchieveStatus();
            qqAchieveEl.show();
            qqHlEl.show();
        }else{
            qqBindEl.find("h1").text(this.bindSNSString.QQ.BIND_TEXT);
            qqBindEl.find("h2").text(this.bindSNSString.QQ.BIND_DESC);
            qqBindBtn.text(resName.BUTTON_SETTING_BIND);
            qqAchieveEl.hide();
            qqHlEl.hide();
        }
    },

     /**
     * 更新QQ成就状态按钮
     */
    updateQQAchieveStatus: function(){
         $("#qq-send-btn").attr("class", window.sdk.security.allow_achivement_send_weibo_tencent ? "check-btn-on" : "check-btn-off");
    },

    /**
     * 更新新浪绑定状态
     */
    updateSinaBind : function(){
        //新浪绑定
        var sinaBindEl =  $("#sina-bind"),
            sinaAchieveEl = $("#sina-sendachieve"),
            sinaBindBtn = $("#sina-bind-btn"),
            sinaHlEl = this.el.find(".sina-hightlight");

        if(DH.isSNSBound(DH.ATTR.BIND_KEY.SINA)){
            sinaBindEl.find("h1").text(this.bindSNSString.SINA.BOUND_TEXT);
            sinaBindEl.find("h2").html(window.sdk.sina.name);
            sinaBindBtn.text(resName.BUTTON_SETTING_CANCEL_BIND);
            this.updateSinaAchieveStatus();
            sinaAchieveEl.show();
            sinaHlEl.show();
        }else{
            sinaBindEl.find("h1").text(this.bindSNSString.SINA.BIND_TEXT);
            sinaBindEl.find("h2").text(this.bindSNSString.SINA.BIND_DESC);
            sinaBindBtn.text(resName.BUTTON_SETTING_BIND);
            sinaAchieveEl.hide();
            sinaHlEl.hide();
        }
    },

    /**
     * 更新新浪成就状态按钮
     */
    updateSinaAchieveStatus: function(){
        //切换按钮
        $("#sina-send-btn").attr("class", window.sdk.security.allow_achivement_send_weibo_sina ? "check-btn-on" : "check-btn-off")
    },

    /**
     * 更新人人网绑定状态
     */
    updateRenrenBind : function(){
        //人人绑定
        var rrBindEl =  $("#renren-bind"),
            rrAchieveEl = $("#renren-sendachieve"),
            rrBindBtn = $("#renren-bind-btn"),
            rrHlEl = this.el.find(".renren-hightlight");

        if(DH.isSNSBound(DH.ATTR.BIND_KEY.RENREN)){
            rrBindEl.find("h1").text(this.bindSNSString.RENREN.BOUND_TEXT);
            rrBindEl.find("h2").html(window.sdk.renren.name);
            rrBindBtn.text(resName.BUTTON_SETTING_CANCEL_BIND);
            this.updateRenRenAchieveStatus();
            rrAchieveEl.show();
            rrHlEl.show();
            rrBindEl.removeClass("memu-last-item");
        }else{
            rrBindEl.find("h1").text(this.bindSNSString.RENREN.BIND_TEXT);
            rrBindEl.find("h2").text(this.bindSNSString.RENREN.BIND_DESC);
            rrBindBtn.text(resName.BUTTON_SETTING_BIND);
            rrAchieveEl.hide();
            rrHlEl.hide();
            rrBindEl.addClass("memu-last-item");
        }
    },

     /**
     * 更新人人成就状态按钮
     */
    updateRenRenAchieveStatus: function(){
         $("#renren-send-btn").attr("class", window.sdk.security.allow_achivement_send_weibo_renren ? "check-btn-on" : "check-btn-off");
    },

    /**
     * 设置当前页面Player信息
     */
    setPlayerInfo : function(){
        var ATTR = DH.ATTR, genderClass = "",DC = DGC.Common;

        this.el.find(".btn").bind(DGC.Common.E_TAP_DOWN, DGC.Common.buttonTapDownHandler)
            .bind(DGC.Common.E_TAP_UP, DGC.Common.buttonTapEndHandler);

        this.el.find(".common-memu-wrap .memu-item:not(.name-memu)")
            .bind(DC.E_TAP_DOWN, DC.listTapDownHandler)
            .bind(DC.E_TAP_UP, DC.listTapEndHandler);

        this.updatePlayerAvatar();

        //点击更新头像
        this.el.find(".icon").bind("tap", { context: this } , function(event){
            var context = event.data.context;

            //记录点：“设定”界面，点击 “修改头像”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_SETTINGS_AVATAR,
                {
                    'user_id': window.sdk.player.id
                }
            );

            //存在头像信息
            if(DH.isSDKAvatarsReady()){
                context.showChangeAvatar(); //直接显示修改头像窗口
            }else{
                context.action.model['me'].queryPreLoadAvatar(); //加载头像信息
            }
        });

        this.updatePlayerName();

        //修改昵称
        $("#modify-name-btn").bind("tap", { context: this } , this.saveNewName);

        this.updatePlayerGender();

        //修改性别
        this.el.find(".sex-btn-wrap > *")
            .bind(DC.E_TAP_DOWN, DC.stopPropagation)
            .bind(DC.E_TAP_UP, DC.stopPropagation);

        this.el.find(".sex-btn-wrap .male").bind('tap',{ context: this, gender: ATTR.GENDER.MALE } , this.changeGender);
        this.el.find(".sex-btn-wrap .female").bind('tap',{ context: this, gender: ATTR.GENDER.FEMALE } , this.changeGender);

        //账户安全
        $("#account-manager").bind("tap", {context: this } , function(event){
            var context = event.data.context;

            //记录点：“设定”界面，点击 “帐号设置”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_SETTINGS_BIND_PHONE,
                {
                    'user_id': window.sdk.player.id
                }
            );

            //如果存在security,则显示修改，否则显示设置
            context.action.setView('PassModify');
        })

        this.updateQQBind();

        //QQ绑定
        $("#qq-bind-btn").bind('tap', {context:this}, function(event){
            var context = event.data.context,
                ATTR = DH.ATTR;

            if(DH.isSNSBound(ATTR.BIND_KEY.QQ)){
                DGC.Common.confirm(
                    resName.TITLE_UNBIND_QQ,
                    resName.TEXT_UNBIND_QQ,
                    function(result){
                        if(result){
                            context.action.model['me'].updateUnbind(ATTR.UNBIND_SNS.QQ);
                        }
                    });
            }else{
                //请求绑定
                context.action.model['me'].updateBindSNS(ATTR.BIND_SNS.QQ);
            }
        });

        //QQ成就发微博
        $("#qq-send-btn")
            .bind(DC.E_TAP_DOWN, DC.stopPropagation)
            .bind(DC.E_TAP_UP, DC.stopPropagation)
            .bind("tap", { context: this } , function(event){
                var context = event.data.context;
                context.action.model['me'].achivementSendWeibo(DH.ATTR.ACHIEVE_SNS.QQ, !window.sdk.security.allow_achivement_send_weibo_tencent);
            });


        this.updateSinaBind();

        //绑定/取消绑定新浪
        $("#sina-bind-btn").bind('tap', {context:this}, function(event){
            var context = event.data.context,
                ATTR = DH.ATTR;
            if(DH.isSNSBound(ATTR.BIND_KEY.SINA)){

                //记录点：“设定”界面，点击 “取消绑定新浪微博”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_SETTINGS_UNBIND_SINA,
                    {
                        'user_id': window.sdk.player.id
                    }
                );

                DGC.Common.confirm(
                    resName.TITLE_UNBIND_SINA,
                    resName.TEXT_UNBIND_SINA,
                    function(result){
                        if(result){
                            context.action.model['me'].updateUnbind(ATTR.UNBIND_SNS.SINA);
                        }
                    });
            }else{
                //记录点：“设定”界面，点击 “绑定新浪微博”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_SETTINGS_BIND_SINA,
                    {
                        'user_id': window.sdk.player.id
                    }
                );

                context.action.showDialog(
                    "SinaDialog",
                    {
                        meModel: context.action.model['me'],
                        bindSuccess : $.bindFn(context.updateSinaBind, context) //绑定成功后执行
                    },
                    function(name, params){
                        //弹出绑定的Dialog
                        this.sina = new DGC.Dialog[name](params);
                        this.sina.show();
                    },
                    context);
            }

        });


        //新浪绑定
        //新浪成就发微博
        $("#sina-send-btn")
            .bind(DC.E_TAP_DOWN, DC.stopPropagation)
            .bind(DC.E_TAP_UP, DC.stopPropagation)
            .bind("tap", { context: this } , function(event){
                var context = event.data.context;
                context.action.model['me'].achivementSendWeibo(DH.ATTR.ACHIEVE_SNS.SINA, !window.sdk.security.allow_achivement_send_weibo_sina);
            });

        this.updateRenrenBind();

        //绑定/取消绑定人人
        $("#renren-bind-btn").bind('tap', {context:this}, function(event){
            var context = event.data.context,
                ATTR = DH.ATTR;
            if(DH.isSNSBound(ATTR.BIND_KEY.RENREN)){

                 //记录点：“设定”界面，点击 “取消绑定人人帐号”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_SETTINGS_UNBIND_RENREN,
                    {
                        'user_id': window.sdk.player.id
                    }
                );

                DGC.Common.confirm(
                    resName.TITLE_UNBIND_RENREN,
                    resName.TEXT_UNBIND_RENREN,
                    function(result){
                        if(result){
                            context.action.model['me'].updateUnbind(ATTR.UNBIND_SNS.RENREN);
                        }
                    });
            }else{

                //记录点：“设定”界面，点击 “绑定人人帐号”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_SETTINGS_BIND_RENREN,
                    {
                        'user_id': window.sdk.player.id
                    }
                );

                context.action.showDialog(
                    "RenRenLoginDialog",
                    {
                        meModel: context.action.model['me'],
                        bindSuccess : $.bindFn(context.updateRenrenBind, context) //绑定成功后执行
                    },
                    function(name, params){
                        //弹出绑定的Dialog
                        this.renren = new DGC.Dialog[name](params);
                        this.renren.show();
                    },
                    context);
            }
        });

        //人人绑定
        //人人成就发新鲜事
        $("#renren-send-btn")
            .bind(DC.E_TAP_DOWN, DC.stopPropagation)
            .bind(DC.E_TAP_UP, DC.stopPropagation)
            .bind("tap", { context: this } , function(event){
                var context = event.data.context;
                context.action.model['me'].achivementSendWeibo(DH.ATTR.ACHIEVE_SNS.RENREN, !window.sdk.security.allow_achivement_send_weibo_renren);
            });

        //关于与反馈
        $("#about-us").bind("tap", { context: this }, function(event){
            var context = event.data.context;

            //记录点：“设定”界面，点击 “绑定人人帐号”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_SETTINGS_ABOUT_US,
                {
                    'user_id': window.sdk.player.id
                }
            );

            context.action.setView('AboutUs');
        });

        //切换账号
        $("#switch-account").bind("tap", { context: this }, this.showPlayerSwitchAccount);
        //清除账号
        $("#clear-account").bind("tap", {context:this} , this.clearPlayerAccount);
    },


    /**
     * 显示修改头像窗口
     */
    showChangeAvatar: function(refresh){
        var params  = {
            meModel: this.action.model['me'],
            sdkAvatars : DGC.Common.getAppConfig("cacheavatars").img,
            parentView : this //依赖View 图片延时加载接口
        };

        if(refresh){
            $.extend(params, { avatarRefresh: true} );
        }


        this.action.showDialog(
            "ChangeAvatar",
            params,
            function(name, params){
                //弹出绑定的Dialog
                this.avatarWin = new DGC.Dialog[name](params);
                this.avatarWin.show();
            },
            this
        );
    },

    /**
     * 保存新昵称信息
     */
    saveNewName: function(event){
        var context = event.data.context,
            newName = $("#modify-name").val();

        //记录点：“设定”界面，点击 “修改昵称”
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_SETTINGS_NICKNAME,
            {
                'user_id': window.sdk.player.id
            }
        );

        //昵称非空
        if($.isEmpty(newName)){
            DGC.ActionUtil.showTipMsg(resName.TIP_MODIFYNAME_NOT_NULL);
            return false;
        }

        DGC.Common.confirm(resName.TIP_SETTING_MODIFYNAME_CONFIRM_TITLE, $.format(resName.TIP_SETTING_MODIFYNAME_CONFIRM_MSG,[newName]), function(result){
            if(result){
                context.action.model['me'].upatePlayerNickName(newName);
            }
        });
        return false;
    },

    /**
     * 修改性别
     */
    changeGender: function(event){
        var context = event.data.context,
            changeGender = event.data.gender,
            ATTR = DH.ATTR,
            genderText = "",
            recordAction;

        //相同性别不用修改
        if(changeGender == window.sdk.player.gender){
            return false;
        }

        switch(changeGender){
            case ATTR.GENDER.MALE:
                genderText = resName.TEXT_SETTING_MALE;
                recordAction = DGC.Event.Option.SEX_MAN;
                break;
            case ATTR.GENDER.FEMALE:
                genderText = resName.TEXT_SETTING_FEMALE;
                recordAction = DGC.Event.Option.SEX_WOMAN;
                break;
        }

        //记录点：用户更新性别(重用新用户性别修改)
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_NEW_USER_UPDATE_SEX,
            {
                'user_id':window.sdk.player.id,
                'sex': recordAction
            }
        );

        DGC.Common.confirm(resName.TIP_SETTING_CHANGEGENDER_CONFIRM_TITLE, $.format(resName.TIP_SETTING_CHANGEGENDER_CONFIRM_MSG,[genderText]), function(result){
            if(result){
                context.action.model['me'].updatePlayerGender(changeGender);
            }
        });
    },

    /**
     * 已选择更新头像方式
     */
    avatarWaySelected : function(selectItem){
        var ATTR = DH.ATTR,
            DAU = DGC.ActionUtil,
            meModel = this.action.model['me'];

        switch(selectItem.value){
            case ATTR.UPDATE_AVATAR.CAMERA:
            case ATTR.UPDATE_AVATAR.LOCAL:
                DAU.updateAvatar(parseInt(selectItem.value, 10));
                break;
            case ATTR.UPDATE_AVATAR.FAKE_SINA:
                meModel.snsSycPlayer(ATTR.SYNC_SNS.SINA, ATTR.SYNC_TYPE.AVATAR);
                break;
            case ATTR.UPDATE_AVATAR.FAKE_RENREN:
                meModel.snsSycPlayer(ATTR.SYNC_SNS.RENREN, ATTR.SYNC_TYPE.AVATAR);
                break;
        }
    },

    /**
     * 切换账号
     */
    showPlayerSwitchAccount: function(event){
        var context = event.data.context,
            tipMsg = "";

        //记录点：“设定”界面，点击 “切换帐号”
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_SETTINGS_SWITCH_ACCOUNT,
            {
                'user_id': window.sdk.player.id
            }
        );

        //手机/SNS未绑定
        if(!DH.isPasswordSet() && !DH.isAnySNSBound() ){
            tipMsg = resName.TIP_SETTING_PHONE_SNS_NOT_BOUND;
        }

        //SNS绑定，手机未绑定
        if(DH.isAnySNSBound() && !DH.isPasswordSet() ){
            tipMsg = resName.TIP_SETTING_SNS_NOT_BOUND;
        }

        if(!$.isEmpty(tipMsg)){
            DGC.Common.confirm(resName.TIP_SETTING_SWITCHACCOUNT_CONFIRM_TITLE, $.format(tipMsg, [ window.sdk.player.nickname]), function(result){
                if(result){
                    //显示登录窗口
                    context.action.showDialog(
                        "UserLogin",
                        {
                            meModel: context.action.model['me'],
                            showModel : DH.ATTR.USER_LOGIN_DIALOG.SWITCH
                        },
                        function(name, params){
                            //弹出绑定的Dialog
                            this.switchWin = new DGC.Dialog[name](params);
                            this.switchWin.show();
                        },
                        context
                    );
                }
            });
        }else{
            //显示登录窗口
            context.action.showDialog(
                "UserLogin",
                {
                    meModel: context.action.model['me'],
                    showModel : DH.ATTR.USER_LOGIN_DIALOG.SWITCH
                },
                function(name, params){
                    //弹出绑定的Dialog
                    this.switchWin = new DGC.Dialog[name](params);
                    this.switchWin.show();
                },
                context
            );
        }

    },

    /**
     * 清除用户信息
     */
    clearPlayerAccount : function(event){
        var context = event.data.context,
            tipMsg = "";

        //记录点：“设定”界面，点击 “清除帐号信息”
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_SETTINGS_CLEAN_ACCOUNT,
            {
                'user_id': window.sdk.player.id
            }
        );

        //手机/SNS未绑定
        if(!DH.isPasswordSet() && !DH.isAnySNSBound() ){
             DGC.Common.confirm(
                resName.TIP_SETTING_CLEARACCOUNT_CONFIRM_TITLE,
                {
                  content:$.format( resName.TIP_SETTING_CLEARACCOUNT_SETPASSWORD, [ window.sdk.player.nickname]),
                  ok_text: resName.BUTTON_SETTING_CLEARACCOUNT_SETPASSWORD ,
                  cancel_text: resName.BUTTON_SETTING_CLEARACCOUNT_CANCEL
                },
                function(result){
                    if(result){
                        //记录点：“清除界面提示”界面，点击 “设置密码”
                        DGC.ActionUtil.recordUserAction(
                            DGC.Event.EventId.EVENT_ME_SETTINGS_CLEAN_ACCOUNT_ACTION,
                            {
                                'user_id': window.sdk.player.id,
                                'clean_account_action_type': DGC.Event.Option.ACTION_SET_PASSWORD
                            }
                        );
                        //跳转到密码设置
                        context.action.setView('PassModify');
                        return false;
                    }else{
                        //记录点：“清除界面提示”界面，点击 “取消”
                        DGC.ActionUtil.recordUserAction(
                            DGC.Event.EventId.EVENT_ME_SETTINGS_CLEAN_ACCOUNT_ACTION,
                            {
                                'user_id': window.sdk.player.id,
                                'clean_account_action_type': DGC.Event.Option.ACTION_CANCEL
                            }
                        );
                    }
                }
            );
            return false;
        }

         //SNS绑定，手机未绑定
        if(DH.isAnySNSBound() && !DH.isPasswordSet() ){
            tipMsg = resName.TIP_SETTING_SNS_NOT_BOUND;
        }else{
            tipMsg = resName.TIP_SETTING_CLEARACCOUNT_CONFIRM_MSG;
        }

        //提示用户
        DGC.Common.confirm(
            resName.TIP_SETTING_CLEARACCOUNT_CONFIRM_TITLE,
            {
              content: $.format( tipMsg, [ window.sdk.player.nickname]),
              ok_text: resName.BUTTON_SETTING_CLEARACCOUNT_OK ,
              cancel_text: resName.BUTTON_SETTING_CLEARACCOUNT_CANCEL
            },
            function(result){
                if(result){
                    //记录点：“清除界面提示”界面，点击 “清除”
                    DGC.ActionUtil.recordUserAction(
                        DGC.Event.EventId.EVENT_ME_SETTINGS_CLEAN_ACCOUNT_ACTION,
                        {
                            'user_id': window.sdk.player.id,
                            'clean_account_action_type': DGC.Event.Option.ACTION_CLEAN
                        }
                    );
                    //注销账号
                    context.action.model['me'].updateCreateAccount();
                }else{
                    //记录点：“清除界面提示”界面，点击 “取消”
                    DGC.ActionUtil.recordUserAction(
                        DGC.Event.EventId.EVENT_ME_SETTINGS_CLEAN_ACCOUNT_ACTION,
                        {
                            'user_id': window.sdk.player.id,
                            'clean_account_action_type': DGC.Event.Option.ACTION_CANCEL
                        }
                    );
                }
            }
        );
    },

    /**
     * 使用新账户
     */
    useNewAccount : function(){
        DGC.ActionUtil.showTipMsg($.format(resName.BUTTON_SETTING_CLEARACCOUNT_SUCCESS,[window.sdk.player.nickname]),function(){
            DGC.ActionUtil.switchNewAccount();
        });
    }
});