/**
 * 绑定人人网
 */
DGC.View.BindSNSRenRen =  $.inherits(DGC.View, {

    baseId : 'bind-renren-view',

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.4.0/js/template/checkpoint/BindSNSRenRen.html",

    /**
     * 状态未完成
     * @type Boolean
     */
    status: false,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var DC = DGC.Common;

        this.setTitle(this.checkpoint.action.name);

        $("#checkpoint-tip").html( $.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']));

        $("#bindButton")
            .bind(DC.E_TAP_DOWN,DC.buttonTapDownHandler)
            .bind(DC.E_TAP_UP,DC.buttonTapEndHandler)
            .bind("tap", {context:this}, this.bindRenRenHandler);
    },

    /**
     * 点击绑定人人网
     */
    bindRenRenHandler: function(event){
        var context = event.data.context,
            username = $("#username").val(),
            password = $("#password").val();

            //帐号不为空
            if($.isEmpty(username)){
                DGC.ActionUtil.showTipMsg(resName.TEXT_RENREN_DIALOG_USERNAME_D);
                return false;
            }

            //密码不为空
            if($.isEmpty(password)){
                DGC.ActionUtil.showTipMsg(resName.TEXT_RENREN_DIALOG_PASSWORD_D);
                return false;
            }

            //提交给feed处理
            context.action.model['me'].updateBindSNS(DH.ATTR.BIND_SNS.RENREN, username, password);
    },

    /**
     * 绑定人人成功
     */
    bindRenRen: function(data){
        //绑定成功后，标识该动作完成，同步只是附加动作
        this.action.model['checkpoint'].updateCheckPoint({
            "cp_id":this.checkpoint.id,
            "ac_id":this.checkpoint.action.id
        });

        this.action.model['me'].snsSycPlayer(DH.ATTR.SYNC_SNS.RENREN, DH.ATTR.SYNC_TYPE.ALL);
    },

    /**
     * 同步人人信息
     */
    sycRenRen : function(result){
        var msg = result ? resName.TIP_BIND_SUCCESS : resName.TIP_SYNCHRONIZED_FAIL;
        DGC.ActionUtil.showTipMsg(msg, function(){
            DGC.ActionUtil.returnToGame();
        });
    },

    /**
     * 通知服务端更新Action状态
     */
    updateCheckPointSuccess: function(){
        this.status = true;
    },

    /**
     * 销毁时动作
     */
    onDestory: function(){
        //关闭View时通知SDK动作状态
        DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
    }

});
