/**
 * "我"的详情视图
 */
DGC.View.DownloadGame =  $.inherits(DGC.View, {

    baseId : 'set-email-view',

    /**
     * 根视图
     */
    isSub: false,

    /**
     * 标题文字
     * @type Boolean
     */
    title : 'A_TITLE_ME_DETAIL',

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.4.0/js/template/checkpoint/DownloadGame.html",

    player : undefined,

    game : undefined,
    /**
     * 动作完成状态，默认未完成
     */
    status : false,

    /**
     * 是否取消通知SDK CP状态
     * @type Boolean
     */
    actionCancel: false,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var self = this;
        this.title = this.checkpoint.action.name;
        DGC.ActionUtil.setTitle(this.title);
        var tips = $.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']);
        $("#checkpoint-tip").html(tips);

        this.gameMSG = $.parseJSON(this.checkpoint.action.extra);
        $("#downloadGame").children("img").attr("src", this.gameMSG.img);

        //判断本地是否安装过
        DGC.ActionUtil.getGameState([this.gameMSG.package_name]);
    },

    /**
     * 游戏状态
     * @param {} gamesStatus
     */
    downloadGameStatus: function(result){
        var status = result.data.states[0],
            btnEl = $("#downloadBtn"),
            DC = DGC.Common,
            self = this;

        btnEl.bind(DGC.Common.E_TAP_DOWN, DC.buttonTapDownHandler)
             .bind(DGC.Common.E_TAP_UP, DC.buttonTapEndHandler);

        if(status){
            btnEl.text(resName.BUTTON_GAMEINFO_PLAY);
            self.status = true; //安装过直接置状态
            btnEl.bind("tap",function(){
                //启动游戏
                DGC.ActionUtil.startGame(self.gameMSG.package_name);
            });
        }else{
            btnEl.text(resName.BUTTON_DOWNLOAD_GAME);
            btnEl.bind("tap",function(){
                self.actionCancel = true; //不通知SDK CP状态

                //checkPoint下载
                DGC.ActionUtil.download(self.gameMSG.download_url, self.gameMSG.package_name, {
                    is_checkpoint: true,
                    action_id: self.checkpoint.action.id,
                    checkpoint_id: self.checkpoint.id
                });
            });
        }
    },

    onDestory : function(){
        if(!this.actionCancel){
            DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
        }
        this.gameMSG = null;
    }
});