/**
 * 积分换CheckPoint
 */
DGC.View.IntegralPay =  $.inherits(DGC.View, {

    baseId : 'integral-paycp-view',

    isDeferRender: false,

    /**
     * 状态未完成
     * @type Boolean
     */
    status: false,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.setTitle(this.checkpoint.action.name);

        //非离线模式，查询积分信息
        if(!window.sdk.isOffline && DH.isSupportIntegral()){
            $.extend(this.requestAPI, { integralReady:false });
            DGC.ActionUtil.getIntegral();
        }
    },

    /**
     * 缓存积分支付方式信息
     */
    cachePaymentDetail: function(payment){
        this.cacheIntegral = payment;

        var needIntegral = parseFloat(this.checkpoint.price * this.cacheIntegral.rate * this.cacheIntegral.discount, 10),
            wall = window.sdk.integralWall;

        //积分不足
        if(needIntegral > wall.integral){
            DGC.ActionUtil.showIntegralView(wall.type, false);
        }else{
            this.action.model['pay'].executePay(11 /*积分换CheckPoint*/, {
                checkpoint : this.checkpoint,
                paymethod : this.cacheIntegral.identifier
            });
        }
    },

    /**
     * 积分支付结果通知
     */
    payActionResult: function(result, detail , failitem){
        var DAU = DGC.ActionUtil,
            context = this;
        context.action.model['pay'].payOrderNotify(11 /*积分方式购买checkPoint*/ , result, detail , failitem, function(){
            //行为完成，通知Action
            context.action.model['checkpoint'].updateCheckPoint({
                "cp_id":context.checkpoint.id,
                "ac_id":context.checkpoint.action.id
             });
        });
    },

    /**
     * 通知服务端更新Action状态
     */
    updateCheckPointSuccess: function(){
        this.status = true;
        //DGC.Common.setAppConfig(this.action.model['checkpoint'].createActionKey(this.checkpoint.action.id), true);
        DGC.ActionUtil.returnToGame();
    },

    /**
     * 关闭赚取积分窗口，回退游戏
     */
    backToGame:function(){
        DGC.ActionUtil.returnToGame();
    },

    /**
     * 销毁时动作
     */
    onDestory: function(){
        //关闭View时通知SDK动作状态
        DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id, true);
    }

});