/**
 * 修改头像
 */
DGC.View.ModifyAvatar = $.inherits(DGC.View, {

    baseId : 'modify-avatar',

    renderTpl : '1.4.0/js/template/checkpoint/ModifyAvatar.html',

    /**
     * SDK头像信息
     */
    sdkAvatars: undefined,

    avatarRefresh: false,
    /**
     * 动作完成状态，默认未完成
     */
    status : false,
    datakey:null,//保存当前点击的图片，保存成功时高亮。
    isLocal:false,//是否是本地上传
    viewReady : function() {
        $("#checkpoint-tip").html($.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']));
        this.action.model['me'].queryPreLoadAvatar(); //加载头像信息
    },
    /**
     * 加载图片成功
     * */
    initSDKAvatar:function(){
        var self = this;
        this.sdkAvatars = DGC.Common.getAppConfig("cacheavatars").img;
        this.loadSDKAvatar();
        this.showSNSAvatar();
        this.bindLocalAvatar();

        //点亮当期头像
        //this.hightLightAvatar();
    },
    /**
     * 加载SDK推荐头像
     */
    loadSDKAvatar: function(){
        var cacheAvatars = this.sdkAvatars;
            avatarWraps  = this.el.find('#default-avatar-content').find(".icon-wrap"),
            loadIcons = [];
        //设置头像KEY
        for(var i = 0; i < cacheAvatars.length ; i++ ){
            var cacheAvatar =  cacheAvatars[i],
                wrap = avatarWraps.get(i);
                imgObj = { url: cacheAvatar.icon , key: cacheAvatar.icon };

            if(this.avatarRefresh){
                $.extend(imgObj, { expire: 1 /*即时过期*/ });
            }
            loadIcons.push(imgObj);
            $(wrap).attr('data-key', cacheAvatar.icon);
            $(wrap).bind('tap', { context: this, key : cacheAvatar.icon}, function(event){
                var key = event.data.key,
                    context = event.data.context;
                context.isLocal = false;
                if(context.isSameAvatar(key)){
                    $(wrap).find(".mask").addClass('active');//如果头像相同，直接完成动作，下同
                    context.setAvatarStatus();
                   // context.destory();
                }else{
                    context.datakey = key;
                    context.action.model['me'].updateAvatarUrl(key);
                }
            });
        }

        //动态加载头像
        this.loadImages(loadIcons, this.repalceAvatar );
    },

    /**
     * 显示当前绑定过的SNS
     */
    showSNSAvatar : function(){
        var ATTR = DH.ATTR ,
            context = this,
            loadIcons = [],
            avatarEl,
            self = this;

        if(!DH.isAnySNSBound()) return false;

        //任意SNS绑定
        if(DH.isSNSBound(ATTR.BIND_KEY.QQ)){
            avatarEl = this.el.find('.qq-avatar');
            avatarEl.attr('data-key', window.sdk.tencent.avatar);
            loadIcons.push({ url: window.sdk.tencent.avatar , key: window.sdk.tencent.avatar });
            avatarEl.bind('tap',function(){
                self.isLocal = false;
                if(context.isSameAvatar(window.sdk.tencent.avatar)){
                   // context.destory();
                    avatarEl.find(".mask").addClass('active');//如果头像相同，直接完成动作，下同
                    context.setAvatarStatus();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.QQ, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }

        if(DH.isSNSBound(ATTR.BIND_KEY.SINA)){
            avatarEl = this.el.find('.sina-avatar');
            avatarEl.attr('data-key', window.sdk.sina.avatar);
            loadIcons.push({ url: window.sdk.sina.avatar , key: window.sdk.sina.avatar });
            avatarEl.bind('tap', function(){
                self.isLocal = false;
                if(context.isSameAvatar(window.sdk.sina.avatar)){
                    // context.destory();
                    avatarEl.find(".mask").addClass('active');
                    context.setAvatarStatus();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.SINA, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }

        if(DH.isSNSBound(ATTR.BIND_KEY.RENREN)){
            avatarEl = this.el.find('.renren-avatar');
            avatarEl.attr('data-key', window.sdk.renren.avatar);
            loadIcons.push({ url: window.sdk.renren.avatar , key: window.sdk.renren.avatar });
            avatarEl.bind('tap', function(){
                 self.isLocal = false;
                if(context.isSameAvatar(window.sdk.renren.avatar)){
                    // context.destory();
                    avatarEl.find(".mask").addClass('active');
                    context.setAvatarStatus();
                }else{
                    context.meModel.snsSycPlayer(ATTR.SYNC_SNS.RENREN, ATTR.SYNC_TYPE.AVATAR);
                }
            });
            avatarEl.show();
        }
        this.el.find('#sns-avatar-content').show();//显示主容器
        if(loadIcons.length > 0){
            this.loadImages(loadIcons, this.repalceAvatar );
        }
    },

    /**
     *  验证是否为相同头像
     */
    isSameAvatar : function(avatar) {
        return (avatar == window.sdk.player.avatar_url);
    },

    /**
     * 绑定本地头像
     */
    bindLocalAvatar : function(){
        var DAU = DGC.ActionUtil,
            AVATAR = DH.ATTR.UPDATE_AVATAR,
            self = this;

        //本地相册
        this.el.find('.local-avatar').bind('tap',function(){
            self.isLocal = true;
            DAU.updateAvatar(AVATAR.LOCAL);
        });

        //拍照
        this.el.find('.camera-avatar').bind('tap',function(){
            self.isLocal = true;
            DAU.updateAvatar(AVATAR.CAMERA);
        });
    },

    /**
     * 点亮当前头像
     */
    hightLightAvatar : function(){
        var avatar_url = window.sdk.player.avatar_url,
            sdkAvatars = this.sdkAvatars;

        if($.isEmpty(avatar_url)) return false; //头像为空，不点亮

        var avatarEl = this.el.find(".icon-wrap[data-key='"+ avatar_url +"']");
        if(avatarEl.size() >  0 ){
            avatarEl.find(".mask").addClass('active');
        }else{
            avatarEl = this.el.find(".user-avatar");
            avatarEl.attr("data-key", avatar_url);
            avatarEl.show();
            //动态加载头像
            this.loadImages({ url: avatar_url, key: avatar_url}, this.repalceAvatar);
        }
    },

    /**
     * 替换动态头像
     */
    repalceAvatar : function(img, data){
        var wrap = $(".icon-wrap[data-key='"+ data.key +"']");
        wrap.find('.default-icon').replaceWith("<img src='"+ img.src +"'></img>");
    },
    /**
     * 头像设置成功
     * */
    setAvatarSuccess:function(){
        this.el.find(".active").removeClass("active");
        if(this.isLocal){
            var avatar_url = window.sdk.player.avatar_url;
            var avatarEl = this.el.find(".user-avatar");
            avatarEl.attr("data-key",avatar_url);
            avatarEl.prepend('<img src="' + avatar_url + '" />').show();
        }else{
            this.el.find(".icon-wrap[data-key='"+this.datakey+"']").find(".mask").addClass("active");
        }
        this.setAvatarStatus();
    },
    /**
     *设置checkpoint状态，服务器状态
     */
    setAvatarStatus:function(){
        this.action.model['checkpoint'].updateCheckPoint({
            "cp_id":this.checkpoint.id,
            "ac_id":this.checkpoint.action.id
         });
    },
    /**
     *设置checkpoint状态，本地状态
     */
    updateCheckPointSuccess:function(){
        this.status = true;
        DGC.ActionUtil.showTipMsg(resName.TIP_SAVE_SUCCESS, function(){
            DGC.ActionUtil.returnToGame();
        });
    },
    onDestory : function(){
         DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
    }
});