/**
 * "我"的详情视图
 */
DGC.View.SetEmail =  $.inherits(DGC.View, {

    baseId : 'set-email-view',

    /**
     * 根视图
     */
    isSub: false,

    /**
     * 标题文字
     * @type Boolean
     */
    title : 'A_TITLE_ME_DETAIL',

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.4.0/js/template/checkpoint/SetEmail.html",

    player : undefined,

    game : undefined,
    /**
     * 动作完成状态，默认未完成
     */
    status : false,
    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var self = this;
        this.title = this.checkpoint.action.name;
        DGC.ActionUtil.setTitle(this.title);
        var tips = $.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']);
        $("#checkpoint-tip").html(tips);
        $("#saveEmail")
            .bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind('tap',function(){
                var EMailReg = /\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/;
                var eMail = $("#setEmail").val();
                var password = $("#setPassword").val();
                var confirm = $("#setConfirm").val();
                if($.isEmpty(eMail)){
                DGC.ActionUtil.showTipMsg(resName.TIP_SET_EMAIL_NOT_EMPTY);
                return false;
            }
            if(!EMailReg.test(eMail)){
                DGC.ActionUtil.showTipMsg(resName.TIP_SET_EMAIL_ERROR_FORMAT);
                return false;
            }
            //密码不为空
            if($.isEmpty(password)){
                DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD);
                return false;
            }
            //确认密码不为空
            if($.isEmpty(confirm)){
                DGC.ActionUtil.showTipMsg(resName.TIP_SET_CONFIRM);
                return false;
            }
            //两次密码不一致
            if(password!=confirm){
                DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD_CONFIRM);
                return false;
            }

            //提交给feed处理
            self.action.model['me'].updateSetPass(eMail,password);
        });
    },
    /**
     *设置checkpoint状态，服务器状态
     */
    updateEmailSuccess:function(){
        this.action.model['checkpoint'].updateCheckPoint({
            "cp_id":this.checkpoint.id,
            "ac_id":this.checkpoint.action.id
         });
    },
    /**
     *设置checkpoint状态，本地状态
     */
    updateCheckPointSuccess:function(){
        this.status = true;
        //DGC.Common.setAppConfig(this.action.model['checkpoint'].createActionKey(this.checkpoint.action.id),true);
        DGC.ActionUtil.showTipMsg(resName.TIP_SAVE_SUCCESS, function(){
            DGC.ActionUtil.returnToGame();
        });
    },
    onDestory : function(){
         DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
    }
});