/**
 * "我"的详情视图
 */
DGC.View.SetPlayerName =  $.inherits(DGC.View, {
    baseId : 'set-player-name-view',
    /**
     * 根视图
     */
    isSub: false,
    /**
     * 标题文字
     * @type Boolean
     */
    title : 'A_TITLE_ME_DETAIL',
    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.4.0/js/template/checkpoint/SetPlayerName.html",
    player : undefined,
    game : undefined,
    /**
     * 动作完成状态，默认未完成
     */
    status : false,
    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var self = this;
        this.title = this.checkpoint.action.name;
        DGC.ActionUtil.setTitle(this.title);
        //提示语
        var tips = $.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']);
        $("#checkpoint-tip").html(tips);

        $("#setName").attr("placeholder", window.sdk.player.nickname);
        //保存用户名
        $("#savePlayName")
            .bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind('tap',function(){
                var playerName = $("#setName").val();
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_SETTINGS_NICKNAME,
                    {
                        'user_id': window.sdk.player.id
                    }
                );
                if($.isEmpty(playerName)){
                    DGC.ActionUtil.showTipMsg(resName.TIP_MODIFYNAME_NOT_NULL);
                    return false;
                }

                DGC.Common.confirm(resName.TIP_SETTING_MODIFYNAME_CONFIRM_TITLE, $.format(resName.TIP_SETTING_MODIFYNAME_CONFIRM_MSG,[playerName]), function(result){
                    if(result){
                        self.action.model['me'].upatePlayerNickName(playerName);
                    }
                });
                return false;
            });
    },
    /**
     *设置checkpoint状态，服务器状态
     */
    setNameSuccess:function(){
        this.action.model['checkpoint'].updateCheckPoint({
            "cp_id":this.checkpoint.id,
            "ac_id":this.checkpoint.action.id
         });
    },
    /**
     *设置checkpoint状态，本地状态
     */
    updateCheckPointSuccess:function(){
        this.status = true;
        //DGC.Common.setAppConfig(this.action.model['checkpoint'].createActionKey(this.checkpoint.action.id),true);
        DGC.ActionUtil.showTipMsg(resName.TIP_SAVE_SUCCESS, function(){
            DGC.ActionUtil.returnToGame();
        });
    },
    onDestory : function(){
         DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
    }
});