/**
 * 分享游戏到人人网 CheckPoint
 */
DGC.View.ShareToRenRen =  $.inherits(DGC.View, {

    baseId : 'share-renren-view',

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.4.0/js/template/checkpoint/ShareToRenRen.html",

    /**
     * 状态未完成
     * @type Boolean
     */
    status: false,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var DC =DGC.Common;

        this.setTitle(this.checkpoint.action.name);

        $("#checkpoint-tip").html( $.format(resName.TEXT_CHECKPOINT_TIPS, [ this.checkpoint.action.name,'<span class="red">“'+ this.checkpoint.name +'”</span>！']));
        this.el.find(".renren-icon").text(window.sdk.player.nickname);

        $("#shareButton")
            .bind(DC.E_TAP_DOWN,DC.buttonTapDownHandler)
            .bind(DC.E_TAP_UP,DC.buttonTapEndHandler)
            .bind("tap",{context:this},this.shareGameToRenRen);

        this.action.model['me'].querySNSShareContent(2/*人人*/);

        this.checkSNSBind();

    },

    /**
     * 成功获得发送消息
     */
    snsContentReady: function(content){
        this.el.find("textarea").val(content.message);
    },

    /**
     * 检查人人网是否已经绑定或过期
     */
    checkSNSBind: function(){
        var ATTR = DH.ATTR,
            params =  {
                meModel: this.action.model['me'],
                cancelFail: this.backToGame
            };

        if(DH.isSNSBound(ATTR.BIND_KEY.RENREN)){
            if(DH.isSNSExpried(ATTR.BIND_KEY.RENREN)){
                $.extend(params,{
                    relogin: true //过期重绑定
                });

                this.action.showDialog("RenRenLoginDialog", params, function(name, params){
                    //弹出绑定的Dialog
                    this.renren = new DGC.Dialog[name](params);
                    this.renren.show();
                },
                this);
            }
        //未绑定
        }else{
            //提示用户先进行绑定
            this.action.showDialog("RenRenLoginDialog", params, function(name, params){
                //弹出绑定的Dialog
                this.renren = new DGC.Dialog[name](params);
                this.renren.show();
            },
            this);
        }
    },

    /**
     * 分享至人人
     */
    shareGameToRenRen: function(event){
        var context = event.data.context,
            value = context.el.find("textarea").val();

        if($.isEmpty(value)){
            DGC.ActionUtil.showTipMsg(resName.TIP_SHAREGAME_CONTENT_NOT_EMPTY);
            return false;
        }

        //字符限制140
        if(value.length > 140){
            DGC.ActionUtil.showTipMsg($.format(resName.TIP_SHAREGAME_CONTENT_LIMIT, [ 140] ));
            return false;
        }

        context.action.model['me'].updateShareContentToSNS( 2/*人人*/, value);
    },



    /**
     * 分享成功
     */
    sendSNSSuccess: function(type, result){
        this.action.model['checkpoint'].updateCheckPoint({
            "cp_id":this.checkpoint.id,
            "ac_id":this.checkpoint.action.id
        });
    },


    /**
     * 通知服务端更新Action状态
     */
    updateCheckPointSuccess: function(){
        var DAU = DGC.ActionUtil;
        this.status = true;
        DAU.showTipMsg(resName.TIP_SHAREGAME_SHARE_SUCCESS,function(){
            DAU.returnToGame();
        });
    },


    /**
     * 关闭绑定窗口，回退游戏
     */
    backToGame:function(){
        DGC.ActionUtil.returnToGame();
    },

    /**
     * 销毁时动作
     */
    onDestory: function(){
        //关闭View时通知SDK动作状态
        DGC.ActionUtil.checkPointStatus(this.status, this.checkpoint.id, this.checkpoint.action.id);
        if(this.renren){
            this.renren.destory();
            this.renren = null;
        }
    }

});
