/**
 * 版本JS/CSS文件加载列表(1.4.0)
 * 文件名规则：版本目录/具体文件路径
 * 版本说明：
 *   SDK1.3基线版本
 */
window.QueenConfig = {

    core: "1.4.0/js/lib/jquery-1.6.2.js",

    js :[
        //公共组件库
        "1.4.0/js/lib/jquery.json-2.2.min.js",
        "1.4.0/js/lib/jquery-utils.js",
        "1.4.0/js/lib/touch-event.js",
        "1.4.0/js/lib/jquery.jqote2.min.js",
        "1.4.0/js/dgc-app.js",
        "1.4.0/js/dgc-service.js",
        "1.4.0/js/dgc-helper.js",
        "1.4.0/js/dgc-util.js",
        "1.4.0/js/dgc-common.js",
        "1.4.0/js/dgc-module.js",
        "1.4.0/js/dgc-dialog.js",
        "1.4.0/js/dgc-model.js",
        "1.4.0/js/dgc-event.js",
        "1.4.0/js/dgc-ads.js",

        //排行榜
        "1.4.0/js/model/HighScoresModel.js",
        "1.4.0/js/module/HighScores.js",

        //我
        "1.4.0/js/model/MeModel.js",
        "1.4.0/js/module/Me.js",

        //成就
        "1.4.0/js/model/AchievementModel.js",
        "1.4.0/js/module/Achievement.js",

        //游戏
        "1.4.0/js/model/GameModel.js",
        "1.4.0/js/module/Game.js",

        //支付
        "1.4.0/js/model/PaymentModel.js",
        "1.4.0/js/module/Payment.js",

        //交叉推广广告
        "1.4.0/js/model/PromotionBannerModel.js",
        "1.4.0/js/module/PromotionBanner.js",

        //CheckPoint
        "1.4.0/js/model/CheckPointModel.js",
        "1.4.0/js/module/CheckPoint.js"
    ],

    /**
     * 视图配置
     */
    viewConfig : {
        //排行榜
        "BoardCategory":{
            js: "1.4.0/js/module/view/BoardCategory.js",
            css: "1.4.0/css/highscores/boardcategory.css"
        },
        "Dashboard":{
            js: "1.4.0/js/module/view/Dashboard.js",
            css: "1.4.0/css/highscores/dashboard.css"
        },
        "OfflineBoard":{
            js: "1.4.0/js/module/view/OfflineBoard.js",
            css: "1.4.0/css/highscores/dashboard.css" //依赖
        },

        //成就
        "UserAchieve": {
            js: "1.4.0/js/module/view/UserAchieve.js",
            css: "1.4.0/css/achievement/achievement.css"
        },

        //游戏
        "LocalGames":{
            js: "1.4.0/js/module/view/LocalGames.js",
            css: "1.4.0/css/game/localgames.css"
        },

        //我
        "MyFriends":{
            js:"1.4.0/js/module/view/MyFriends.js",
            css: "1.4.0/css/person/myfriends.css"
        },
        "FriendsToFriends":{
            js:"1.4.0/js/module/view/FriendsToFriends.js",
            css:"1.4.0/css/person/friendstofriends.css"
        },
        "GameInfo":{
            js:"1.4.0/js/module/view/GameInfo.js",
            css:"1.4.0/css/person/gameinfo.css"
        },
        "PlayedGames":{
            js:"1.4.0/js/module/view/PlayedGames.js",
            css:"1.4.0/css/person/playedgame.css"
        },
        "MyDetail":{
            js:"1.4.0/js/module/view/MyDetail.js",
            css:"1.4.0/css/person/mydetail.css"
        },
        "InviteFriends":{
            js: "1.4.0/js/module/view/InviteFriends.js",
            css:"1.4.0/css/person/invitefriends.css"
        },
        "SwitchUser":{
            js: "1.4.0/js/module/view/SwitchUser.js",
            css: "1.4.0/css/person/switchuser.css"
        },
        "Setting":{
            js: "1.4.0/js/module/view/Setting.js",
            css: "1.4.0/css/person/setting.css"
        },
        "ModifyName":{
            js:"1.4.0/js/module/view/ModifyName.js",
            css:"1.4.0/css/person/modifyname.css"
        },
        "PassModify":{
            js:"1.4.0/js/module/view/PassModify.js",
            css:"1.4.0/css/person/passmodify.css",
        },
        "CreateAccount":{
            js: "1.4.0/js/module/view/CreateAccount.js",
            css: "1.4.0/css/person/createaccount.css"
        },
        "FriendsDetail":{
            js: "1.4.0/js/module/view/FriendsDetail.js",
            css:[
                "1.4.0/css/person/mydetail.css",
                "1.4.0/css/person/friendsdetail.css"
            ]
        },
        "ChargeHistory":{
             js:"1.4.0/js/module/view/ChargeHistory.js",
             css:"1.4.0/css/person/chargehistory.css"
        },
        "ChargeAccount":{
            js: "1.4.0/js/module/view/ChargeAccount.js",
            css: "1.4.0/css/person/chargeaccount.css"
        },
        "ChargeCommit":{
            js:"1.4.0/js/module/view/ChargeCommit.js",
            css: "1.4.0/css/person/chargecommit.css" //depend on
        },
        "ChargeResult":{
            js: "1.4.0/js/module/view/ChargeResult.js",
            css: "1.4.0/css/person/chargeresult.css" //depend on
        },
        "AboutUs":{
            js:"1.4.0/js/module/view/AboutUs.js",
            css: "1.4.0/css/person/aboutus.css"
        },
        "BindSina":{
            js: "1.4.0/js/module/view/BindSina.js",
            css: "1.4.0/css/person/bindsina.css",
            cfg: {
                needTips: false //不需要请求Tips
            }
        },
        "Activity":{
            js: "1.4.0/js/module/view/Activity.js",
            css: "1.4.0/css/person/activity.css"
        },
        "PromoteCode":{
            js: "1.4.0/js/module/view/PromoteCode.js",
            css: "1.4.0/css/person/promotecode.css"
        },
        "PromoteCodeHelp":{
            js: "1.4.0/js/module/view/PromoteCodeHelp.js",
            css: "1.4.0/css/person/promotecodehelp.css"
        },
        "DeveloperPromote":{
            js: "1.4.0/js/module/view/DeveloperPromote.js",
            cfg: {
                needTips: false
            }
        },
        "ActivityDetail":{
            js: "1.4.0/js/module/view/ActivityDetail.js",
            css:[
                "1.4.0/css/person/activitydetail.css"
            ]
        },
        //支付
        "LeDouShop":{
            js: "1.4.0/js/module/view/LeDouShop.js",
            css: "1.4.0/css/payment/ledoushop.css",
            cfg: {
                needTips: false
            }
        },
        "DeveloperPay":{
            js: "1.4.0/js/module/view/DeveloperPay.js",
            cfg: {
                needTips: false
            }
        },
        "DeveloperPayUser":{
            js: "1.4.0/js/module/view/DeveloperPayUser.js",
            cfg: {
                needTips: false
            }
        },
        "PayCommit":{
            js:"1.4.0/js/module/view/PayCommit.js",
            css: "1.4.0/css/person/chargecommit.css" //depend
        },
        "PayResult":{
            js: "1.4.0/js/module/view/PayResult.js",
            css: "1.4.0/css/person/chargeresult.css" //depend
        },
        "OfflineCharge":{
            js:"1.4.0/js/module/view/OfflineCharge.js",
            css:"1.4.0/css/person/chargeaccount.css" //depend
        },
        /*
         *checkpoint模块样式共用
         */
        "SetEmail":{
            js:"1.4.0/js/module/view/checkpoint/SetEmail.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "SetPlayerName":{
            js:"1.4.0/js/module/view/checkpoint/SetPlayerName.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "DownloadGame":{
            js:"1.4.0/js/module/view/checkpoint/DownloadGame.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "IntegralPay":{
            js:"1.4.0/js/module/view/checkpoint/IntegralPay.js"
        },
        "ModifyAvatar":{
            js:"1.4.0/js/module/view/checkpoint/ModifyAvatar.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "BindSNSSina":{
            js:"1.4.0/js/module/view/checkpoint/BindSNSSina.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "ShareToRenRen":{
            js:"1.4.0/js/module/view/checkpoint/ShareToRenRen.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "BindSNSRenRen":{
            js:"1.4.0/js/module/view/checkpoint/BindSNSRenRen.js",
            css: "1.4.0/css/person/checkpoint.css"
        },
        "ShareToSina":{
            js:"1.4.0/js/module/view/checkpoint/ShareToSina.js",
            css:"1.4.0/css/person/checkpoint.css"
        },
        "BindQQ":{
            js:"1.4.0/js/module/view/checkpoint/BindQQ.js",
            css:"1.4.0/css/person/checkpoint.css"
        }
    },

    /**
     * 弹出窗口配置
     */
    dialogConfig: {
        "RenRenLoginDialog":{
            js: "1.4.0/js/module/view/RenRenLoginDialog.js",
            css: "1.4.0/css/dialog/renrenlogindialog.css"
        },
        "SinaDialog":{
            js: "1.4.0/js/module/view/SinaDialog.js",
            css: "1.4.0/css/dialog/sinadialog.css"
        },
        "UserLogin":{
            js: "1.4.0/js/module/dialog/UserLogin.js",
            css:  "1.4.0/css/dialog/userlogin.css"
        },
        "PayHelpDialog":{
            js: "1.4.0/js/module/view/PayHelpDialog.js",
            css: "1.4.0/css/dialog/payhelpdialog.css"
        },
        "ShopDetail":{
            js: "1.4.0/js/module/view/ShopDetail.js",
            css: "1.4.0/css/dialog/shopdetail.css"
        },
        "ShareGame":{
            js:"1.4.0/js/module/dialog/ShareGame.js",
            css:"1.4.0/css/dialog/sharegame.css"
        },
        "ChangeAvatar":{
            js: "1.4.0/js/module/dialog/ChangeAvatar.js",
            css: "1.4.0/css/dialog/changeavatar.css"
        }
    },

    css : [
        //重置应用JS
        "1.4.0/css/reset.css",
        "1.4.0/css/common.css",
        "1.4.0/css/app.css"
    ]
}